'FEM計算の実行ﾌﾟﾛｸﾞﾗﾑ（ﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽ法）
'分割計算の外部入出力廃止
Imports System.Drawing

Public Class ElMa3DCal4
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.PictureBox2 = New System.Windows.Forms.PictureBox()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(128, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(240, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "電磁界解析計算の実行（バンドマトリックス法）"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(38, 12)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(128, 192)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(152, 24)
        Me.PictureBox1.TabIndex = 3
        Me.PictureBox1.TabStop = False
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(128, 136)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(256, 24)
        Me.PictureBox2.TabIndex = 4
        Me.PictureBox2.TabStop = False
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 248)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(400, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'ElMa3DCal4
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(496, 302)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.PictureBox2)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "ElMa3DCal4"
        Me.Text = "ElMa3DCal4"
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Dim SwK As IO.StreamWriter  '結果出力用

    Dim NBvar As Integer        '非ｾﾞﾛ固定の変数の数
    Dim Neff As Integer         '縮小ﾏﾄﾘｯｸｽの行列数
    Dim NxF As Integer          'FEM行列分割時の1行列の変数の数

    Dim Fw1, Fw2 As Single      '進行表示の水平枠位置

    Dim KBfix() As Integer      '非ｾﾞﾛ固定の変数番号
    Dim Kmag() As Integer       '材料の磁化有無
    Dim KVarMax(13) As Integer  '変数の最大値の節点番号
    Dim Lcomp() As Integer      '全変数の縮小ﾏﾄﾘｯｸｽ変数番号
    Dim Nrest() As Integer      '固定全節点の節点順位
    Dim Nw() As Integer         '各節点の共通要素数
    Dim Nw2() As Integer        '渦電流要素で各節点の共通要素数

    Dim Area() As Double        '材料毎の断面積
    Dim Ek(,) As Double         '要素計算の２次配列
    Dim Qq(20) As Double        '内部電荷の節点への換算量
    Dim RIe(), RIeb() As Double '材料毎の電流
    Dim RImp(), RImpb() As Double   '材料毎のｲﾝﾋﾟｰﾀﾞﾝｽ計算用変数
    Dim RImpP(), RImpPb() As Double '電流負荷節点のｲﾝﾋﾟｰﾀﾞﾝｽ計算用変数
    Dim Tf() As Double          'FEM計算の右辺ﾍﾞｸﾄﾙ
    Dim Tfbuf() As Double       'FEM計算の右辺ﾍﾞｸﾄﾙのﾊﾞｯﾌｧｰ
    Dim TfOld() As Double       '前回の解
    Dim TfOldx() As Double      '前々回の解
    Dim Tk(,) As Double         'FEM行列
    Dim TUA() As Double         '合成ﾍﾞｸﾄﾙ
    Dim TUvec() As Double       'ﾍﾞｸﾄﾙ配列
    Dim TUvec2() As Double      '渦電流密度のﾍﾞｸﾄﾙ配列
    Dim Ua() As Double          '解の一次記憶ﾍﾞｸﾄﾙ
    Dim VarMax(13) As Single    '変数の最大値
    Dim VBfix() As Double       '非ｾﾞﾛ固定値
    Dim WEddy() As Double       '材料毎の渦電力

    Private Sub BandWidth(ByRef mb As Integer)
        'ﾊﾞﾝﾄﾞ幅の計算
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim i, ibx, ie, ii, j, jj, k, k1, k2, nmax As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        mb = 0
        For ie = 1 To Nelem
            ii = 0
            jj = 0
            For i = 1 To nmax
                ibx = NNelem(ie, i)
                k1 = Ndim * (Kcomp(ibx) - 1)
                For j = 1 To Ndim
                    k1 = k1 + 1
                    k2 = Lcomp(k1)
                    If k2 > 0 Then
                        If ii = 0 Then
                            ii = k2
                            jj = k2
                        ElseIf k2 < ii Then
                            ii = k2
                        ElseIf k2 > jj Then
                            jj = k2
                        End If
                    End If
                Next j
            Next i
            k = jj - ii
            If k > mb Then
                mb = k
            End If
        Next ie
        mb = mb + 1
    End Sub

    Private Sub BoundSort()
        '非ｾﾞﾛ固定のｿｰﾃｨﾝｸﾞ
        Dim i, ii, j, kb As Integer
        Dim b1 As Single
        For i = 1 To NBvar - 1
            kb = i
            For j = i + 1 To NBvar
                If KBfix(j) < KBfix(kb) Then
                    kb = j
                End If
            Next j
            ii = KBfix(kb)
            b1 = VBfix(kb)
            KBfix(kb) = KBfix(i)
            VBfix(kb) = VBfix(i)
            KBfix(i) = ii
            VBfix(i) = b1
        Next i
    End Sub

    Private Sub DebugTf(ByVal nx As Integer)
        '右辺ﾍﾞｸﾄﾙを出力して停止
        'nx･･･変数の数
        Dim aa$, fdebug$
        Dim i, id, ii As Integer

        aa$ = ""
        ii = FreeFile()
        fdebug$ = DirOpen$ + "\ElMa3DCal4debug.dat"
        FileOpen(ii, fdebug$, OpenMode.Output)
        id = 0
        For i = 1 To nx
            If id = 0 Then
                aa$ = Str(Tf(i))
            Else
                aa$ = aa$ + ",  " + Str(Tf(i))
            End If
            If id = 4 Then
                PrintLine(ii, aa$)
                id = 0
            Else
                id = id + 1
            End If
        Next i
        If id = 0 Then
            PrintLine(ii, aa$)
        End If
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug1()
        '全変数の縮小ﾏﾄﾘｯｸｽ変数番号を出力して停止
        Dim aa$, fxx$
        Dim i, ib, j, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\ElMa3DCal4debug1.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "縮小マトリックス用変換配列データ"
        WriteLine(ii, aa$)
        WriteLine(ii, "節点番号、節点順序、各次元の縮小ﾏﾄﾘｯｸｽ変数番号")
        For i = 1 To Npoint
            ib = Kcomp(i)
            aa$ = Str$(i) + ",  " + Str$(ib)
            For j = 1 To Ndim
                aa$ = aa$ + ",  " + Str$(Lcomp(ib))
            Next j
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug2(ByVal kbuf() As Integer, ByVal kbbuf() As Integer)
        '2つの面の節点番号を出力して停止
        Dim aa$, fxx$
        Dim i, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\ElMa3DCal4debug1.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "２つの面の節点番号"
        WriteLine(ii, aa$)
        WriteLine(ii, "面１")
        aa$ = Str$(kbuf(1))
        For i = 2 To 8
            aa$ = aa$ + ",  " + Str$(kbuf(i))
        Next i
        PrintLine(ii, aa$)
        WriteLine(ii, "面２")
        aa$ = Str$(kbbuf(1))
        For i = 2 To 8
            aa$ = aa$ + ",  " + Str$(kbbuf(i))
        Next i
        PrintLine(ii, aa$)
        FileClose(ii)
        Stop
    End Sub

    Private Sub EddyPower()
        '渦電力の計算
        Dim i, icount, ie, ig, ii, jg, kg, kmat, nmax, numg As Integer
        Dim b1, b2, b3, coeff, dj, dv, s, t, u As Double
        ReDim WEddy(Nmat)  '渦電力

        If KindElem = 0 Then
            nmax = 20
        End If
        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            kmat = NumMat(ie)
            b1 = DataMat(kmat, 2)
            If b1 > 0 Then
                coeff = 1 / b1
                For ii = 1 To nmax
                    i = NNelem(ie, ii)
                    XE(ii) = Xdata(i)
                    YE(ii) = Ydata(i)
                    ZE(ii) = Zdata(i)
                    TE(ii) = TUvec(Kcomp(i))
                Next ii
                b2 = 0
                If KindElem = 0 Then
                    numg = 0
                    For ig = 1 To Ngaus
                        s = PosGaus(ig)
                        For jg = 1 To Ngaus
                            t = PosGaus(jg)
                            For kg = 1 To Ngaus
                                numg = numg + 1
                                u = PosGaus(kg)
                                Call ShapeFunc(1, s, t, u)         '形状関数の計算
                                Call JacobElem(ie, 1, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                                dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                                For i = 1 To 20
                                    b3 = Shape(i) * TE(i)
                                    b2 = b2 + b3 * b3 * dv
                                Next i
                            Next kg
                        Next jg
                    Next ig
                End If
                WEddy(kmat) = WEddy(kmat) + coeff * b2
            End If
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

    End Sub

    Private Sub ElecField(ByVal ie As Integer, ByVal k As Integer, _
    ByRef hx As Double, ByRef hy As Double, ByRef hz As Double)
        '電界計算
        'ie･･･要素番号
        'k･･･節点番号
        'hx,hy,hz･･･X,Y,Z方向の電界
        Dim i, ig, ii, j, jg, jmax, kg, kh, kk, nmax, numg As Integer
        Dim b1, b2, b3, dj, s, t, tuxp, tuyp, tuzp, u As Double
        Dim tuxg(27), tuyg(27), tuzg(27) As Double

        If KindElem = 0 Then
            jmax = 27
            nmax = 20
        End If
        For j = 1 To nmax
            i = NNelem(ie, j)
            If i = k Then
                kk = j
            End If
            XE(j) = Xdata(i) : YE(j) = Ydata(i) : ZE(j) = Zdata(i)
            ii = Kcomp(i)
            TE(j) = Tf(Lcomp(ii))
        Next j

        If KindElem = 0 Then
            numg = 0
            For ig = 1 To Ngaus
                s = PosGaus(ig)
                For jg = 1 To Ngaus
                    t = PosGaus(jg)
                    For kg = 1 To Ngaus
                        numg = numg + 1
                        u = PosGaus(kg)
                        Call ShapeFunc(1, s, t, u)         '形状関数の計算
                        Call JacobElemC(ie, numg, kh, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                        b1 = 0 : b2 = 0 : b3 = 0
                        For j = 1 To 20
                            b1 = b1 + Dx(j) * TE(j)
                            b2 = b2 + Dy(j) * TE(j)
                            b3 = b3 + Dz(j) * TE(j)
                        Next j
                        tuxg(numg) = tuxg(numg) + b1
                        tuyg(numg) = tuyg(numg) + b2
                        tuzg(numg) = tuzg(numg) + b3
                    Next kg
                Next jg
            Next ig
        End If

        tuxp = 0 : tuyp = 0 : tuzp = 0
        For j = 1 To jmax
            b1 = Tr(kk, j)
            tuxp = tuxp + b1 * tuxg(j)
            tuyp = tuyp + b1 * tuyg(j)
            tuzp = tuzp + b1 * tuzg(j)
        Next j

        hx = hx - tuxp
        hy = hy - tuyp
        hz = hz - tuzp

    End Sub

    Private Sub ElecForce()
        'ｸ-ﾛﾝ力の計算
        Dim aa$
        Dim i, ie, j, k, nb, nmax As Integer
        Dim fall, fx, fy, fz, hx, hy, hz As Double

        aa$ = "＜電荷番号, 節点番号、Ｆcx、Ｆcy、Ｆcz、Ｆcall（絶対値）＞"
        SwK.WriteLine("-----------------------------------------------")
        SwK.WriteLine("＊＊ 節点電荷が受けるクーロン力 ＊＊")
        SwK.WriteLine(aa$)

        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To NelecP
            k = KelecP(i)
            nb = 0 : hx = 0 : hy = 0 : hz = 0
            For ie = 1 To Nelem
                For j = 1 To nmax
                    If NNelem(ie, j) = k Then
                        Call ElecField(ie, k, hx, hy, hz)  '電界計算
                        nb = nb + 1
                        Exit For
                    End If
                Next j
            Next ie
            fx = QelecP(i) * hx / nb
            fy = QelecP(i) * hy / nb
            fz = QelecP(i) * hz / nb
            fall = Math.Sqrt(fx * fx + fy * fy + fz * fz)
            aa$ = Space(6) + Str(i) + ",  " + Str(k)
            aa$ = aa$ + ",  " + Str(CSng(fx)) + ",  " + Str(CSng(fy))
            aa$ = aa$ + ",  " + Str(CSng(fz)) + ",  " + Str(CSng(fall))
            SwK.WriteLine(aa$)
        Next i

    End Sub

    Private Sub ElecForce2()
        '電荷部のｸ-ﾛﾝ力の計算
        Dim aa$
        Dim i, icount, ie, j, nb As Integer
        Dim qb As Single
        Dim b1, fall As Double
        Dim fbuf(3) As Double

        nb = 0
        For i = 1 To Nmat
            If DataMat(i, 2) <> 0 Then
                nb = 1
                Exit For
            End If
        Next i
        If nb = 0 Then
            Exit Sub
        End If

        aa$ = "＜材料番号、Ｆcvx、Ｆcvy、Ｆcvz、Ｆcvall（絶対値）＞"
        SwK.WriteLine("-----------------------------------------------")
        SwK.WriteLine("＊＊ 電荷部が受けるクーロン力 ＊＊")
        SwK.WriteLine(aa$)

        For i = 1 To Nmat
            qb = DataMat(i, 2)
            If qb <> 0 Then
                For j = 1 To 3
                    fbuf(j) = 0
                Next j
                Application.DoEvents()
                icount = 0
                For ie = 1 To Nelem
                    If NumMat(ie) = i Then
                        Call ElemMatrixQF(ie, qb, fbuf)    '要素ﾏﾄﾘｯｸｽの計算QF
                        If icount < 99 Then
                            icount = icount + 1
                        Else
                            Application.DoEvents()
                            icount = 0
                        End If
                    End If
                Next ie
                aa$ = Space(6) + Str(i)
                b1 = 0
                For j = 1 To 3
                    aa$ = aa$ + ",  " + Str(CSng(fbuf(j)))
                    b1 = b1 + fbuf(j) ^ 2
                Next j
                fall = Math.Sqrt(b1)
                aa$ = aa$ + ",  " + Str(CSng(fall))
                SwK.WriteLine(aa$)
            End If
        Next i

    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer, ByVal iter As Integer)
        '要素ﾏﾄﾘｯｸｽの計算（静電界、静磁界用）
        'ie･･･要素番号
        Dim i, id, ig, ii, j, jg, jj, k, kg, kh, kmat, nmax, numg As Integer
        Dim b1, b2, coeff, dj, dv, s, t, tempb, u As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            TEA(ii) = TUA(Kcomp(i))
        Next ii
        For i = 1 To Nvar
            For j = 1 To Nvar
                Ek(i, j) = 0
            Next j
        Next i
        kmat = NumMat(ie)
        If KindField = 0 Then
            coeff = DataMat(kmat, 1)
        End If

        If KindElem = 0 Then
            numg = 0
            For ig = 1 To Ngaus
                s = PosGaus(ig)
                For jg = 1 To Ngaus
                    t = PosGaus(jg)
                    For kg = 1 To Ngaus
                        numg = numg + 1
                        u = PosGaus(kg)
                        Call ShapeFunc(1, s, t, u)         '形状関数の計算
                        Call JacobElemC(ie, numg, kh, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                        dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                        If KindField > 0 Then
                            If Kmag(kmat) = 0 Then
                                tempb = TGA(numg)
                                Call StateCalc(kmat, coeff, tempb)   '物性状態の計算
                                If KindField = 2 Then
                                    coeff = 1 / coeff
                                End If
                            Else
                                coeff = 1 / Rmyu(KMenv, 0)
                            End If
                        End If
                        For i = 1 To 20
                            For j = i To 20
                                b1 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                                b2 = coeff * b1 * dv
                                If KindField < 2 Then
                                    Ek(i, j) = Ek(i, j) + b2
                                Else
                                    ii = Ndim * (i - 1)
                                    jj = Ndim * (j - 1)
                                    For k = 1 To 3
                                        ii = ii + 1
                                        jj = jj + 1
                                        Ek(ii, jj) = Ek(ii, jj) + b2
                                    Next k
                                End If
                            Next j
                        Next i
                    Next kg
                Next jg
            Next ig
        End If

        j = 0
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            k = Ndim * (Kcomp(i) - 1)
            For id = 1 To Ndim
                j = j + 1 : k = k + 1
                NPrefer(j) = Lcomp(k)
            Next id
        Next ii

    End Sub

    Private Sub ElemMatrixC(ByVal ie As Integer, ByVal mh As Integer, _
    ByVal nbase As Integer, ByVal i1 As Integer, ByVal i2 As Integer, _
    ByRef kset As Integer)
        '要素ﾏﾄﾘｯｸｽの計算C（準定常電磁界用）
        'ie･･･要素番号
        'mh･･･流れ計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nbase･･･分割行列の変数ﾍﾞｰｽ番号
        'i1,i2･･･分割行列におけ変数の開始番号、終了番号
        'kset･･･対象変数の有無（0:なし、1:有り）
        Dim i, ib, ic, id, ig, ii, it, j, jb, jg, jj As Integer
        Dim k, kg, kmat, n1, n2, nmax, numg As Integer
        Dim b1, b2, b3, b4, b5, coeff, coeff1, coeff2 As Double
        Dim dv, dj, s, t, u As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        j = 0
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            k = Ndim * (Kcomp(i) - 1)
            For id = 1 To Ndim
                j = j + 1 : k = k + 1
                NPrefer(j) = Lcomp(k)
            Next id
        Next ii
        If NDmatrix > 1 Then
            kset = 1
            ic = 0
            n1 = nbase + i1 - mh + 1
            If n1 < 1 Then
                n1 = 1
            End If
            n2 = nbase + i2
            For i = 1 To Nvar
                it = NPrefer(i)
                If n1 <= it And it <= n2 Then
                    ic = 1
                    Exit For
                End If
            Next i
            If ic = 0 Then
                kset = 0
                Exit Sub
            End If
        End If

        For ii = 1 To nmax
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
        Next ii
        For i = 1 To Nvar
            For j = 1 To Nvar
                Ek(i, j) = 0
            Next j
        Next i
        kmat = NumMat(ie)
        coeff = 1 / DataMat(kmat, 1)
        coeff1 = DataMat(kmat, 2)
        coeff2 = Dpai * Cycle * coeff1

        If KindElem = 0 Then
            numg = 0
            For ig = 1 To Ngaus
                s = PosGaus(ig)
                For jg = 1 To Ngaus
                    t = PosGaus(jg)
                    For kg = 1 To Ngaus
                        numg = numg + 1
                        u = PosGaus(kg)
                        Call ShapeFunc(1, s, t, u)         '形状関数の計算
                        Call JacobElem(ie, 1, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                        dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                        For i = 1 To 20
                            b2 = coeff1 * Shape(i) * dv
                            b3 = coeff2 * Shape(i) * dv
                            ii = Ndim * (i - 1)
                            For j = 1 To 20
                                jj = Ndim * (j - 1)
                                b1 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                                ib = ii - 1
                                jb = jj - 1
                                b4 = coeff * b1 * dv
                                b5 = b3 * Shape(j)
                                For k = 1 To 3
                                    ib = ib + 2
                                    jb = jb + 2
                                    Ek(ib, jb) = Ek(ib, jb) + b4
                                    Ek(ib + 1, jb + 1) = Ek(ib + 1, jb + 1) + b4
                                    Ek(ib, jb + 1) = Ek(ib, jb + 1) - b5
                                    Ek(ib + 1, jb) = Ek(ib + 1, jb) + b5
                                Next k
                                ib = ii - 1
                                jb = jj + 7
                                For k = 1 To 3
                                    ib = ib + 2
                                    Select Case k
                                        Case 1
                                            b4 = b2 * Dx(j)
                                        Case 2
                                            b4 = b2 * Dy(j)
                                        Case 3
                                            b4 = b2 * Dz(j)
                                    End Select
                                    Ek(ib, jb) = Ek(ib, jb) + b4
                                    Ek(ib + 1, jb + 1) = Ek(ib + 1, jb + 1) + b4
                                Next k
                                ib = ii + 7
                                jb = jj - 1
                                For k = 1 To 3
                                    jb = jb + 2
                                    Select Case k
                                        Case 1
                                            b4 = b3 * Dx(j)
                                        Case 2
                                            b4 = b3 * Dy(j)
                                        Case 3
                                            b4 = b3 * Dz(j)
                                    End Select
                                    Ek(ib, jb + 1) = Ek(ib, jb + 1) + b4
                                    Ek(ib + 1, jb) = Ek(ib + 1, jb) - b4
                                Next k
                                b4 = coeff1 * b1 * dv
                                ib = ii + 7
                                jb = jj + 7
                                Ek(ib, jb) = Ek(ib, jb) + b4
                                Ek(ib + 1, jb + 1) = Ek(ib + 1, jb + 1) + b4
                            Next j
                        Next i
                    Next kg
                Next jg
            Next ig
        End If

    End Sub

    Private Sub ElemMatrixF(ByVal ie As Integer, ByVal imat As Integer, ByRef fbuf() As Double)
        '要素ﾏﾄﾘｯｸｽの計算F（力ﾍﾞｸﾄﾙ計算用）
        'ie･･･要素番号
        'imat･･･材料番号
        'fbuf()･･･各座標軸方向の力
        Dim i, ib, ig, ii, j1, j2, jg, k, kg, nmax, numg As Integer
        Dim b1, bx, by, bz, dj, dv, qx, qy, qz, s, t, u As Double
        Dim bxe(20), bye(20), bze(20), dcos(3) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            k = Kcomp(i)
            ib = 3 * (k - 1)
            bxe(ii) = TUvec(ib + 1)
            bye(ii) = TUvec(ib + 2)
            bze(ii) = TUvec(ib + 3)
        Next ii

        If KindJdef(imat) = 0 Then
            j1 = 1 : j2 = 3
            qx = DataMat(imat, 1)
            qy = DataMat(imat, 2)
            qz = DataMat(imat, 3)
        Else
            j1 = 2 : j2 = 2
            k = DataMat(imat, 1)
            Call Surf2Vector(ie, k, dcos)   '対面方向ﾍﾞｸﾄﾙの計算
            b1 = DataMat(imat, 2)
            qx = b1 * dcos(1)
            qy = b1 * dcos(2)
            qz = b1 * dcos(3)
        End If

        If KindElem = 0 Then
            numg = 0
            For ig = 1 To Ngaus
                s = PosGaus(ig)
                For jg = 1 To Ngaus
                    t = PosGaus(jg)
                    For kg = 1 To Ngaus
                        u = PosGaus(kg)
                        numg = numg + 1
                        Call ShapeFunc(1, s, t, u)         '形状関数の計算
                        Call JacobElem(ie, 0, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                        dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                        bx = 0 : by = 0 : bz = 0
                        For ii = 1 To 20
                            bx = bx + Shape(ii) * bxe(ii)
                            by = by + Shape(ii) * bye(ii)
                            bz = bz + Shape(ii) * bye(ii)
                        Next ii
                        fbuf(1) = fbuf(1) + qy * bz - qz * by
                        fbuf(2) = fbuf(2) + qz * bx - qx * bz
                        fbuf(3) = fbuf(3) + qx * by - qy * bx
                    Next kg
                Next jg
            Next ig
        End If

    End Sub

    Private Sub ElemMatrixQF(ByVal ie As Integer, ByVal qb As Single, ByRef fbuf() As Double)
        '要素ﾏﾄﾘｯｸｽの計算QF
        'ie･･･要素番号
        'qb･･･電荷密度
        'fbuf()･･･各座標軸方向の力
        Dim i, ib, ig, ii, jg, kg, nmax, numg As Integer
        Dim bx, by, bz, dj, dv, s, t, u As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            ib = Kcomp(i)
            TE(ii) = Tf(Lcomp(ib))
        Next ii

        If KindElem = 0 Then
            numg = 0
            For ig = 1 To Ngaus
                s = PosGaus(ig)
                For jg = 1 To Ngaus
                    t = PosGaus(jg)
                    For kg = 1 To Ngaus
                        u = PosGaus(kg)
                        numg = numg + 1
                        Call ShapeFunc(1, s, t, u)         '形状関数の計算
                        Call JacobElem(ie, 0, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                        dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                        bx = 0 : by = 0 : bz = 0
                        For ii = 1 To 20
                            bx = bx + Dx(ii) * Shape(ii) * TE(ii)
                            by = by + Dy(ii) * Shape(ii) * TE(ii)
                            bz = bz + Dz(ii) * Shape(ii) * TE(ii)
                        Next ii
                        fbuf(1) = fbuf(1) - qb * bx
                        fbuf(2) = fbuf(2) - qb * by
                        fbuf(3) = fbuf(3) - qb * bz
                    Next kg
                Next jg
            Next ig
        End If

    End Sub

    Private Sub ElemMatrixV(ByVal ie As Integer)
        '要素ﾏﾄﾘｯｸｽの計算V（密度ﾍﾞｸﾄﾙ計算用）
        'ie･･･要素番号
        Dim i, ib, ig, ii, j, jg, jmax, k, kg, kh, nmax, numg, kmat As Integer
        Dim b1, b2, coeff, coeff1, coeff2, dj, s, t, tempb, u As Double
        Dim buf(6), buf2(6), tug(27, 6), tug2(27, 6) As Double

        If KindElem = 0 Then
            jmax = 27
            nmax = 20
        End If
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            If KindField = 1 Then
                TEA(ii) = TUA(Kcomp(i))
            End If
            ib = Ndim * (ii - 1)
            k = Ndim * (Kcomp(i) - 1)
            For j = 1 To Ndim
                TE(ib + j) = Tf(Lcomp(k + j))
            Next j
        Next ii
        kmat = NumMat(ie)
        If KindField > 0 Then
            coeff = 1
        Else
            coeff = DataMat(kmat, 1)
        End If
        If KindField = 3 Then
            coeff1 = DataMat(kmat, 2)
            coeff2 = Dpai * Cycle
        End If

        If KindElem = 0 Then
            numg = 0
            For ig = 1 To Ngaus
                s = PosGaus(ig)
                For jg = 1 To Ngaus
                    t = PosGaus(jg)
                    For kg = 1 To Ngaus
                        numg = numg + 1
                        u = PosGaus(kg)
                        Call ShapeFunc(1, s, t, u)         '形状関数の計算
                        Call JacobElemC(ie, numg, kh, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                        For i = 1 To 6
                            buf(i) = 0
                            buf2(i) = 0
                        Next i
                        If KindField < 3 Then
                            If KindField < 2 Then
                                For i = 1 To 20
                                    For j = 1 To 3
                                        Select Case j
                                            Case 1
                                                b1 = Dx(i) * TE(i)
                                            Case 2
                                                b1 = Dy(i) * TE(i)
                                            Case 3
                                                b1 = Dz(i) * TE(i)
                                        End Select
                                        buf(j) = buf(j) - b1
                                    Next j
                                Next i
                            Else
                                For i = 1 To 20
                                    ib = 3 * (i - 1)
                                    For j = 1 To 3
                                        Select Case j
                                            Case 1
                                                b1 = Dy(i) * TE(ib + 3) - Dz(i) * TE(ib + 2)
                                            Case 2
                                                b1 = Dz(i) * TE(ib + 1) - Dx(i) * TE(ib + 3)
                                            Case 3
                                                b1 = Dx(i) * TE(ib + 2) - Dy(i) * TE(ib + 1)
                                        End Select
                                        buf(j) = buf(j) + b1
                                    Next j
                                Next i
                            End If
                        Else
                            For i = 1 To 20
                                ib = 8 * (i - 1)
                                For j = 1 To 3
                                    Select Case j
                                        Case 1
                                            b1 = Dy(i) * TE(ib + 5) - Dz(i) * TE(ib + 3)
                                            b2 = Dy(i) * TE(ib + 6) - Dz(i) * TE(ib + 4)
                                        Case 2
                                            b1 = Dz(i) * TE(ib + 1) - Dx(i) * TE(ib + 5)
                                            b2 = Dz(i) * TE(ib + 2) - Dx(i) * TE(ib + 6)
                                        Case 3
                                            b1 = Dx(i) * TE(ib + 3) - Dy(i) * TE(ib + 1)
                                            b2 = Dx(i) * TE(ib + 4) - Dy(i) * TE(ib + 2)
                                    End Select
                                    buf(2 * j - 1) = buf(2 * j - 1) + b1
                                    buf(2 * j) = buf(2 * j) + b2
                                Next j
                                For j = 1 To 3
                                    Select Case j
                                        Case 1
                                            b1 = -Dx(i) * TE(ib + 7) + coeff2 * TE(ib + 2)
                                            b2 = -Dx(i) * TE(ib + 8) - coeff2 * TE(ib + 1)
                                        Case 2
                                            b1 = -Dy(i) * TE(ib + 7) + coeff2 * TE(ib + 4)
                                            b2 = -Dy(i) * TE(ib + 8) - coeff2 * TE(ib + 3)
                                        Case 3
                                            b1 = -Dz(i) * TE(ib + 7) + coeff2 * TE(ib + 6)
                                            b2 = -Dz(i) * TE(ib + 8) - coeff2 * TE(ib + 5)
                                    End Select
                                    buf2(2 * j - 1) = buf2(2 * j - 1) + b1
                                    buf2(2 * j) = buf2(2 * j) + b2
                                Next j
                            Next i
                        End If

                        If KindField = 1 Then
                            tempb = TGA(numg)
                            Call StateCalc(kmat, coeff, tempb)   '物性状態の計算
                        End If
                        If KindField < 3 Then
                            For j = 1 To 3
                                buf(j) = coeff * buf(j)
                            Next j
                        Else
                            For j = 1 To 6
                                buf2(j) = coeff1 * buf2(j)
                            Next j
                        End If

                        For i = 1 To 6
                            tug(numg, i) = tug(numg, i) + buf(i)
                            tug2(numg, i) = tug2(numg, i) + buf2(i)
                        Next i
                    Next kg
                Next jg
            Next ig
        End If

        For i = 1 To nmax
            For j = 1 To 6
                buf(j) = 0
                buf2(j) = 0
            Next j
            For j = 1 To jmax
                b1 = Tr(i, j)
                For k = 1 To 6
                    buf(k) = buf(k) + b1 * tug(j, k)
                    buf2(k) = buf2(k) + b1 * tug2(j, k)
                Next k
            Next j
            ii = NNelem(ie, i)
            If KindField < 3 Then
                ib = 3 * (Kcomp(ii) - 1)
                For j = 1 To 3
                    TUvec(ib + j) = TUvec(ib + j) + buf(j)
                Next j
            Else
                ib = 6 * (Kcomp(ii) - 1)
                For j = 1 To 6
                    TUvec(ib + j) = TUvec(ib + j) + buf(j)
                    TUvec2(ib + j) = TUvec2(ib + j) + buf2(j)
                Next j
            End If
        Next i

    End Sub

    Private Sub ElemMatrixZ(ByVal ii As Integer, ByRef da2 As Double, _
    ByRef dep As Double, ByRef depb As Double)
        '要素ﾏﾄﾘｯｸｽの計算Z（ｲﾝﾋﾟｰﾀﾞﾝｽ計算用）
        'ii･･･要素番号
        'da2･･･対面の平均面積
        'dep、depb･･･誘起電圧の実数部、虚数部
        Dim ib, j, jb, jset, jj, jx As Integer
        Dim k, k1, k2, kb, kgp1, kgp2, kind, numg As Integer
        Dim b1, b2, da, dj, rlen As Double
        Dim kbuf(8) As Integer
        Dim buf1(3), buf2(3), gpos(3), tbuf1(2), tbuf2(2) As Double
        jx = DataMat(NumMat(ii), 3)
        jb = jx Mod 2
        If jb = 0 Then
            jb = jx - 1
        Else
            jb = jx + 1
        End If
        For j = 1 To 20
            ib = NNelem(ii, j)
            XE(j) = Xdata(ib)
            YE(j) = Ydata(ib)
            ZE(j) = Zdata(ib)
            b1 = 0 : b2 = 0
            ib = Ndim * (Kcomp(ib) - 1)
            For jj = 1 To 3
                ib = ib + 1
                b1 = b1 + Tf(Lcomp(ib)) ^ 2
                ib = ib + 1
                b2 = b2 + Tf(Lcomp(ib)) ^ 2
            Next jj
            TE(j) = Math.Sqrt(b1)
            TEA(j) = Math.Sqrt(b2)
        Next j
        da2 = 0
        For k = 1 To 2
            If k = 1 Then
                jset = jx
            Else
                jset = jb
            End If
            Call SurfaceCond(jset, kind, kbuf, gpos)
            '境界条件用の面設定

            For j = 1 To 8
                ib = j Mod 2
                If ib > 0 Then
                    b1 = -0.25
                Else
                    b1 = 0.5
                End If
                kb = kbuf(j)
                If k = 1 Then
                    buf1(1) = buf1(1) + b1 * XE(kb)
                    buf1(2) = buf1(2) + b1 * YE(kb)
                    buf1(3) = buf1(3) + b1 * ZE(kb)
                    tbuf1(1) = tbuf1(1) + b1 * TE(kb)
                    tbuf1(2) = tbuf1(2) + b1 * TEA(kb)
                Else
                    buf2(1) = buf2(1) + b1 * XE(kb)
                    buf2(2) = buf2(2) + b1 * YE(kb)
                    buf2(3) = buf2(3) + b1 * ZE(kb)
                    tbuf2(1) = tbuf2(1) + b1 * TE(kb)
                    tbuf2(2) = tbuf2(2) + b1 * TEA(kb)
                End If
            Next j
            Select Case kind
                Case 1
                    kgp1 = 1
                    kgp2 = 2
                    jj = 3
                Case 2
                    kgp1 = 1
                    kgp2 = 3
                    jj = 2
                Case 3
                    kgp1 = 2
                    kgp2 = 3
                    jj = 1
            End Select

            numg = 0
            For k1 = 1 To Ngaus
                gpos(kgp1) = PosGaus(k1)
                For k2 = 1 To Ngaus
                    gpos(kgp2) = PosGaus(k2)
                    numg = numg + 1
                    Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                    '形状関数の計算

                    Call JacobElem2(ii, numg, dj, kbuf)
                    '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                    da = 0
                    For j = 1 To 3
                        b1 = RinvJ(j, jj)
                        da = da + b1 * b1
                    Next j
                    da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)
                    da2 = da2 + da
                Next k2
            Next k1
        Next k
        da2 = 0.5 * da2
        rlen = 0
        For j = 1 To 3
            b1 = buf2(j) - buf1(j)
            rlen = rlen + b1 * b1
        Next j
        rlen = Math.Sqrt(rlen)
        dep = 0.5 * (tbuf1(2) + tbuf2(2)) * rlen * da2
        depb = -0.5 * (tbuf1(1) + tbuf2(1)) * rlen * da2

    End Sub

    Private Sub FluctCheck(ByRef bb As Double, ByRef bba As Double)
        '解の発散ﾁｪｯｸ
        'bb･･･解変化量の最大値
        'bba･･･収束基準量（解最大値×収束基準変化率）
        Dim ip As Integer
        Dim aa, cc, dd As Double
        aa = 0
        bb = 0
        For ip = 1 To Neff
            cc = Math.Abs(Tf(ip))
            dd = Math.Abs(Tf(ip) - TfOld(ip))
            If cc > aa Then
                aa = cc
            End If
            If dd > bb Then
                bb = dd
            End If
        Next ip
        bba = aa * EpsCalc

    End Sub

    Private Sub FluxSet()
        '流束の節点への換算
        '静電界、静磁界（電流なし）の場合のみ
        Dim i, ib, ie, ii, j, jj, k1, k2, kb, kgp1, kgp2 As Integer
        Dim kind, kk, nmax, numg As Integer
        Dim b1, da, dj, pnb As Double
        Dim kbuf(8) As Integer
        Dim gpos(3) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To Nflux
            ie = KsurfFlux(ii, 1)
            kb = KsurfFlux(ii, 2)
            If KindElem = 0 Then
                Call SurfaceCond(kb, kind, kbuf, gpos)  '境界条件用の面設定
            End If

            For j = 1 To nmax
                ib = NNelem(ie, j)
                XE(j) = Xdata(ib)
                YE(j) = Ydata(ib)
                ZE(j) = Zdata(ib)
            Next j

            pnb = Pnorm(ii)
            If KindElem = 0 Then
                Select Case kind
                    Case 1
                        kgp1 = 1
                        kgp2 = 2
                        jj = 3
                    Case 2
                        kgp1 = 1
                        kgp2 = 3
                        jj = 2
                    Case 3
                        kgp1 = 2
                        kgp2 = 3
                        jj = 1
                End Select

                numg = 0
                For k1 = 1 To Ngaus
                    gpos(kgp1) = PosGaus(k1)
                    For k2 = 1 To Ngaus
                        gpos(kgp2) = PosGaus(k2)
                        numg = numg + 1
                        Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                        '形状関数の計算

                        Call JacobElem2(ie, numg, dj, kbuf)
                        '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                        da = 0
                        For i = 1 To 3
                            b1 = RinvJ(i, jj)
                            da = da + b1 * b1
                        Next i
                        da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)
                        For i = 1 To 8
                            kk = kbuf(i)
                            j = Kcomp(NNelem(ie, kk))
                            Tf(Lcomp(j)) = Tf(Lcomp(j)) - pnb * Shape(kk) * da
                        Next i
                    Next k2
                Next k1
            End If
        Next ii

    End Sub

    Private Sub ForceCalc()
        '力の計算
        Dim aa$
        Dim ic, icount, ie, imat, j, j1, j2, kind As Integer
        Dim b1, fall As Double
        Dim fbuf(3) As Double

        aa$ = "＜材料番号、Ｆx、Ｆy、Ｆz、Ｆall（絶対値）＞"
        SwK.WriteLine("-----------------------------------------------")
        SwK.WriteLine("＊＊ 電流部が受けるローレンツ力 ＊＊")
        SwK.WriteLine(aa$)

        For imat = 1 To Nmat
            If KindJdef(imat) = 0 Then
                j1 = 1 : j2 = 3
                kind = 0
            Else
                j1 = 2 : j2 = 2
                kind = 1
            End If
            ic = 0
            For j = j1 To j2
                If DataMat(imat, j) <> 0 Then
                    ic = 1
                    Exit For
                End If
            Next j
            If ic > 0 Then
                For j = 1 To 3
                    fbuf(j) = 0
                Next j
                Application.DoEvents()
                icount = 0
                For ie = 1 To Nelem
                    If NumMat(ie) = imat Then
                        Call ElemMatrixF(ie, imat, fbuf)    '要素ﾏﾄﾘｯｸｽの計算F
                        If icount < 99 Then
                            icount = icount + 1
                        Else
                            Application.DoEvents()
                            icount = 0
                        End If
                    End If
                Next ie
                aa$ = Space(6) + Str(imat)
                b1 = 0
                For j = 1 To 3
                    aa$ = aa$ + ",  " + Str(CSng(fbuf(j)))
                    b1 = b1 + fbuf(j) ^ 2
                Next j
                fall = Math.Sqrt(b1)
                aa$ = aa$ + ",  " + Str(CSng(fall))
                SwK.WriteLine(aa$)
            End If
        Next imat

    End Sub

    Private Sub Impedance()
        'ｲﾝﾋﾟｰﾀﾞﾝｽの計算
        Dim i, ib, ic, icount, ie, ii, jb, jx, kh, knum As Integer
        Dim coeff, da2, dasum, dep, depb, depbsum, depsum, rnum As Double
        Dim kbuf(8), kbbuf(8) As Integer

        coeff = Dpai * Cycle
        For i = 1 To Nmat
            If KindJdef(i) > 0 And DataMat(i, 4) <> 0 Then
                jx = DataMat(i, 3)
                jb = jx Mod 2
                If jb = 0 Then
                    jb = jx - 1
                Else
                    jb = jx + 1
                End If
                Dim nbuf(Nelem) As Integer
                knum = 0
                Application.DoEvents()
                icount = 0
                For ie = 1 To Nelem
                    If NumMat(ie) = i And nbuf(ie) = 0 Then
                        knum = knum + 1
                        nbuf(ie) = knum
                        ib = ie
                        Do
                            Call SurfaceSet(ib, jb, kbbuf)   '面の設定
                            ic = 0
                            For ii = ie + 1 To Nelem
                                If NumMat(ii) = i And nbuf(ii) = 0 Then
                                    Call SurfaceSet(ii, jx, kbuf)   '面の設定
                                    Call SurfCheck(kh, kbuf, kbbuf) '同一面の判定
                                    If kh > 0 Then
                                        ic = 1
                                        nbuf(ii) = knum
                                        ib = ii
                                        Exit For
                                    End If
                                End If
                            Next ii
                        Loop While ic > 0
                        rnum = 0
                        dasum = 0 : depsum = 0 : depbsum = 0
                        For ii = ie To Nelem
                            If nbuf(ii) = knum Then
                                rnum = rnum + 1.0
                                Call ElemMatrixZ(ii, da2, dep, depb)
                                '要素ﾏﾄﾘｯｸｽの計算Z（ｲﾝﾋﾟｰﾀﾞﾝｽ計算用）
                                dasum = dasum + da2
                                depsum = depsum + dep
                                depbsum = depbsum + depb
                            End If
                        Next ii
                        dasum = dasum / rnum
                        Area(i) = Area(i) + dasum
                        RImp(i) = RImp(i) + coeff * depsum
                        RImpb(i) = RImp(i) + coeff * depbsum
                    End If
                    If icount < 99 Then
                        icount = icount + 1
                    Else
                        Application.DoEvents()
                        icount = 0
                    End If
                Next ie
                RIe(i) = DataMat(i, 4) * Area(i)
                RImp(i) = RImp(i) / Area(i)
                RImpb(i) = RImpb(i) / Area(i)
            End If
        Next i

    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim aa$, timn$
        Dim i, ib, ie, ii, imax, j, jj, jmax, jx, k, kb, ndimb, nmax As Integer
        Dim kbuf(8) As Integer
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "初期設定処理1  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        If KindElem = 0 Then
            imax = 6
            jmax = 8
            nmax = 20
        End If
        Nvar = Ndim * nmax
        Nall = Ndim * Npoint
        ReDim Ek(Nvar, Nvar)
        ReDim NPrefer(Nvar), Nw(Npoint), Kmag(Nmat)
        ReDim TE(Nvar)

        If KindField = 2 Then
            For i = 1 To Nmat
                Select Case KindJdef(i)
                    Case 2
                        For j = 1 To 3
                            If DataMat(i, j) <> 0 Then
                                Kmag(i) = 1
                                Exit For
                            End If
                        Next j
                    Case 3
                        If DataMat(i, 1) > 0 And DataMat(i, 2) <> 0 Then
                            Kmag(i) = 1
                        End If
                End Select
            Next i
        End If

        If KindField = 3 Then
            ReDim Nw2(Npoint)
            ReDim Area(Nmat), RImp(Nmat), RImpb(Nmat)
            ReDim RIe(Nmat), RIeb(Nmat)   '電流の実数部と虚数部
            For k = 1 To Nmat
                If DataMat(k, 2) > 0 Then
                    For i = 1 To Nelem
                        If NumMat(i) = k Then
                            For ii = 1 To nmax
                                ib = Kcomp(NNelem(i, ii))
                                Nw2(ib) = Nw2(ib) + 1
                            Next ii
                        End If
                    Next i
                End If
            Next k
        End If

        '節点の重複要素数の計算
        For ie = 1 To Nelem
            For ii = 1 To nmax
                i = Kcomp(NNelem(ie, ii))
                Nw(i) = Nw(i) + 1
            Next ii
        Next ie

        '固定境界ﾃﾞｰﾀの処理
        If KindField < 3 Then
            ndimb = Ndim
        Else
            ndimb = 4
        End If
        Dim jfix(Npoint, ndimb) As Integer
        Dim vfix(Npoint, ndimb) As Single
        If KindField = 3 Then   '準定常電磁界解析の場合の電位設定
            For ie = 1 To Nelem
                k = NumMat(ie)
                If DataMat(k, 2) = 0 Then
                    For ii = 1 To nmax
                        i = NNelem(ie, ii)
                        If jfix(i, 4) = 0 Then
                            jfix(i, 4) = 2
                            vfix(i, 4) = 0
                        End If
                    Next ii
                End If
            Next ie
            For ie = 1 To Nelem
                k = NumMat(ie)
                If DataMat(k, 2) <> 0 Then
                    For ii = 1 To nmax
                        i = NNelem(ie, ii)
                        jfix(i, 4) = 0
                    Next ii
                End If
            Next ie
        End If
        If NboundP > 0 Then
            For i = 1 To NboundP
                k = NrestP(i)
                For j = 1 To ndimb
                    jx = JdirectP(i, j)
                    If jx = 0 Then
                        jx = -2
                    Else
                        jx = 2
                    End If
                    jfix(k, j) = jx
                    vfix(k, j) = VdirectP(i, j)
                Next j
            Next i
        End If
        If NboundS > 0 Then
            For i = 1 To NboundS
                ib = 0
                For j = 1 To ndimb
                    If JdirectS(i, j) > 0 Then
                        ib = 1
                        Exit For
                    End If
                Next j
                If ib > 0 Then
                    ie = NrestS(i, 1)
                    kb = NrestS(i, 2)
                    If KindElem = 0 Then
                        Call SurfaceSet(ie, kb, kbuf)   '面の設定
                    End If
                    For j = 1 To jmax
                        k = kbuf(j)
                        For jj = 1 To ndimb
                            jx = JdirectS(i, jj)
                            If jx > 0 Then
                                If jfix(k, jj) = 0 Then
                                    jfix(k, jj) = 2
                                    vfix(k, jj) = VdirectS(i, jj)
                                End If
                            End If
                        Next jj
                    Next j
                End If
            Next i
            For i = 1 To NboundS
                ib = 0
                For j = 1 To ndimb
                    If JdirectS(i, j) = 0 Then
                        ib = 1
                        Exit For
                    End If
                Next j
                If ib > 0 Then
                    ie = NrestS(i, 1)
                    kb = NrestS(i, 2)
                    If KindElem = 0 Then
                        Call SurfaceSet(ie, kb, kbuf)   '面の設定
                    End If
                    For j = 1 To jmax
                        k = kbuf(j)
                        For jj = 1 To ndimb
                            jx = JdirectS(i, jj)
                            If jx = 0 Then
                                If jfix(k, jj) = 0 Then
                                    jfix(k, jj) = -1
                                    vfix(k, jj) = VdirectS(i, jj)
                                End If
                            End If
                        Next jj
                    Next j
                End If
            Next i
        End If

        '流束境界の処理
        If Nflux > 0 Then
            For i = 1 To Nflux
                ie = KsurfFlux(i, 1)
                kb = KsurfFlux(i, 2)
                If KindElem = 0 Then
                    Call SurfaceSet(ie, kb, kbuf)   '面の設定
                End If
                For j = 1 To jmax
                    k = kbuf(j)
                    For jj = 1 To ndimb
                        If jfix(k, jj) = 0 Then
                            jfix(k, jj) = -1
                        End If
                    Next jj
                Next j
            Next i
        End If

        If KindBound = 0 Then   '境界自動固定の処理
            aa$ = "境界自動固定の処理  "
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)
            ReDim KdrawElem(Nelem), KSelem(Nelem, 6)
            For ie = 1 To Nelem
                KdrawElem(ie) = 1
            Next ie
            Call InnerCheck2(1, Nelem)    '内面ﾁｪｯｸ
            Application.DoEvents()
            If NboundS > 0 Then
                For i = 1 To NboundS
                    ie = NrestS(i, 1)
                    kb = NrestS(i, 2)
                    KSelem(ie, kb) = -1
                Next i
            End If
            If Nflux > 0 Then
                For i = 1 To Nflux
                    ie = KsurfFlux(i, 1)
                    kb = KsurfFlux(i, 2)
                    KSelem(ie, kb) = -1
                Next i
            End If
            For ie = 1 To Nelem
                For i = 1 To imax
                    If KSelem(ie, i) = 0 Then   '外郭面の場合
                        If KindElem = 0 Then
                            Call SurfaceSet(ie, i, kbuf)    '面の設定
                        End If
                        For j = 1 To jmax
                            k = kbuf(j)
                            For jj = 1 To ndimb
                                jx = jfix(k, jj)
                                If jx = 0 Or jx = -1 Then
                                    jfix(k, jj) = 1
                                    vfix(k, jj) = 0
                                End If
                            Next jj
                        Next j
                    End If
                Next i
            Next ie
        End If

        '縮小ﾏﾄﾘｯｸｽの設定
        ReDim Lcomp(Nall)
        For i = 1 To Nall       '全変数のﾏﾄﾘｯｸｽ組み入れを仮設定
            Lcomp(i) = 1
        Next i
        For i = 1 To Npoint
            k = Ndim * (Kcomp(i) - 1)
            For j = 1 To ndimb
                If jfix(i, j) > 0 Then
                    If vfix(i, j) = 0 Then
                        If KindField < 3 Then
                            Lcomp(k + j) = 0
                        Else
                            kb = k + 2 * j
                            Lcomp(kb - 1) = 0
                            Lcomp(kb) = 0
                        End If
                    End If
                End If
            Next j
        Next i
        Neff = 0
        For i = 1 To Nall       '全変数の縮小ﾏﾄﾘｯｸｽへの対応付け
            If Lcomp(i) > 0 Then
                Neff = Neff + 1
                Lcomp(i) = Neff
            End If
        Next i

        ReDim Tf(Neff), TUA(Npoint)
        If KindField = 3 Then
            ReDim Tfbuf(Neff)
        End If

        If NKmax > 1 Then
            ReDim TfOld(Neff), TfOldx(Neff)
        End If

        If KindField < 3 Then
            i = 3
        Else
            i = 6
        End If
        j = i * Npoint
        ReDim TUvec(j)
        If KindField = 3 Then
            ReDim TUvec2(j)
        End If

        '非ｾﾞﾛ固定の整理
        NBvar = 0
        For i = 1 To Npoint
            k = Ndim * (Kcomp(i) - 1)
            For j = 1 To ndimb
                If jfix(i, j) > 0 And vfix(i, j) <> 0 Then
                    NBvar = NBvar + 1
                End If
            Next j
        Next i
        ReDim KBfix(NBvar), VBfix(NBvar)
        jj = 0
        For i = 1 To Npoint
            k = Ndim * (Kcomp(i) - 1)
            For j = 1 To ndimb
                If jfix(i, j) > 0 And vfix(i, j) <> 0 Then
                    jj = jj + 1
                    If KindField < 3 Then
                        kb = k + j
                    Else
                        kb = k + 2 * j - 1
                    End If
                    KBfix(jj) = Lcomp(kb)
                    VBfix(jj) = vfix(i, j)
                End If
            Next j
        Next i
        Call BoundSort()    '非ｾﾞﾛ固定のｿｰﾃｨﾝｸﾞ

        gr.Dispose()

    End Sub

    Private Sub MagForce2()
        '磁気力の計算2
        Dim aa$
        Dim icount, ie, imat, j, k, kmax As Integer
        Dim rmyu0 As Single
        Dim b1, fall As Double
        Dim mbuf(6) As Integer
        Dim fbuf(3) As Double

        aa$ = "＜材料番号、Ｆmx、Ｆmy、Ｆmz、Ｆmall（絶対値）＞"
        SwK.WriteLine("-----------------------------------------------")
        SwK.WriteLine("＊＊ 磁性体が受ける磁気力 ＊＊")
        SwK.WriteLine(aa$)

        If KindElem = 0 Then
            kmax = 6
        End If
        rmyu0 = Rmyu(KMenv, 0)

        For imat = 1 To Nmat
            If NMdiv(imat) > 1 Then
                For j = 1 To 3
                    fbuf(j) = 0
                Next j
                Application.DoEvents()
                icount = 0
                For ie = 1 To Nelem
                    If NumMat(ie) = imat Then
                        Call OutSurfCheck(ie, mbuf)  '面外部の材料ﾁｪｯｸ
                        For k = 1 To kmax
                            If mbuf(k) = KMenv Then
                                Call SurfMagForce2(ie, k, rmyu0, fbuf)    '要素面の磁気力2
                            End If
                        Next k
                        If icount < 99 Then
                            icount = icount + 1
                        Else
                            Application.DoEvents()
                            icount = 0
                        End If
                    End If
                Next ie
                b1 = 0
                For j = 1 To 3
                    b1 = b1 + fbuf(j) ^ 2
                Next j
                fall = Math.Sqrt(b1)
                If fall > 0 Then
                    aa$ = Space(6) + Str(imat)
                    For j = 1 To 3
                        aa$ = aa$ + ",  " + Str(CSng(fbuf(j)))
                    Next j
                    aa$ = aa$ + ",  " + Str(CSng(fall))
                    SwK.WriteLine(aa$)
                End If
            End If
        Next imat

    End Sub

    Private Sub MatrixCalcD(ByVal mh As Integer)
        'ﾏﾄﾘｯｸｽ計算（分割計算）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim i, i1, i1b, i2, i2b, icount, ie, ii, j, j1, jj As Integer
        Dim k, k1, k2, kb, kd, kk, kset As Integer
        Dim mx, nbase, ni1, ni2, nn, nx, nxx As Integer
        Dim count, cmax As Single
        Dim ub As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Application.DoEvents()
        timn$ = ""
        count = 0
        cmax = NDmatrix * (NDmatrix + 1) / 2
        mx = 2 * mh - 1
        For kk = NDmatrix To 1 Step -1
            If kk = NDmatrix Then
                nx = Neff
            Else
                nx = NxF * kk
            End If
            For i = 1 To nx
                Tf(i) = Tfbuf(i)
            Next i

            For kd = 1 To kk  'FEM分割行列の計算（境界固定を含む）
                nbase = NxF * (kd - 1)   'ﾍﾞｰｽの変数の数
                If kd = 1 Then
                    i1 = 1
                    i1b = 1
                Else
                    i1 = mx
                    i1b = mh
                End If
                If kd < kk Then     'i2は分割行列の流れﾏﾄﾘｯｸｽ計算範囲
                    i2 = NxF + mx - 1
                    i2b = NxF + mh - 1
                Else
                    i2 = nx - nbase
                    i2b = i2
                End If
                If kd > 1 Then
                    For i = 1 To mx - 1
                        ii = NxF + i
                        For j = 1 To mx
                            Tk(i, j) = Tk(ii, j)
                        Next j
                    Next i
                End If
                For i = i1 To i2
                    For j = 1 To mx
                        Tk(i, j) = 0
                    Next j
                Next i
                If kd < kk Then     'nxxは分割行列の前進計算範囲
                    nxx = NxF
                Else
                    nxx = i2
                End If

                ni1 = nbase + i1b
                ni2 = nbase + i2b
                nn = ni2 + mh - 1
                If nn > nx Then
                    nn = nx
                End If

                Application.DoEvents()
                icount = 0
                For ie = 1 To Nelem
                    aa$ = "要素" + Str$(ie) + "   "
                    Call TimCal(1, timn$)
                    aa$ = aa$ + timn$
                    gr.Clear(Color.White)
                    gr.DrawString(aa$, fnt, myBrush, 1, 1)
                    Call ElemMatrixC(ie, mh, nbase, i1, i2, kset)     '要素ﾏﾄﾘｯｸｽの計算C

                    If kset > 0 Then
                        Call StoreAD(mh, nbase, i1, i2)        '全体ﾏﾄﾘｯｸｽへの蓄積A
                    End If
                    If icount < 99 Then
                        icount = icount + 1
                    Else
                        Application.DoEvents()
                        icount = 0
                    End If
                Next ie

                For i = 1 To NBvar
                    k = KBfix(i)
                    If ni1 <= k And k <= ni2 Then
                        ub = VBfix(i)
                        For ii = nbase + 1 To nn
                            kb = ii - nbase
                            If ii = k Then
                                For j = 1 To mx
                                    If j = mh Then
                                        Tk(kb, j) = 1
                                    Else
                                        Tk(kb, j) = 0
                                    End If
                                Next j
                                Tf(ii) = ub
                            Else
                                j = k + mh - ii
                                If j > 0 And j <= mx Then
                                    Tf(ii) = Tf(ii) - Tk(kb, j) * ub
                                    Tk(kb, j) = 0
                                End If
                            End If
                        Next ii
                    End If
                Next i

                If kk < NDmatrix And kd = kk Then   '既知変数の代入
                    For k = nxx - mh + 2 To nxx
                        j1 = nxx - k + 2
                        For j = j1 To mh
                            kb = nbase + k
                            ii = kb + j - 1
                            jj = j + mh - 1
                            Tf(kb) = Tf(kb) - Tk(k, jj) * Tf(ii)
                            Tk(k, jj) = 0
                        Next j
                    Next k
                End If

                k1 = nbase + 1
                k2 = nbase + nxx
                If kd < kk Then
                    nn = nxx + mh - 1
                Else
                    nn = nxx
                End If
                Call Solver1AD(mh, k1, k2, nn) 'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1AD（前進側）
                Application.DoEvents()

                count = count + 1.0
                ProgressBar1.Value = 80 * count / cmax

            Next kd

            nbase = NxF * (kk - 1)   'ﾍﾞｰｽの変数の数
            k1 = nbase + 1
            k2 = nx
            Call Solver2AD(mh, k1, k2) 'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2AD（後退側）
            Application.DoEvents()

        Next kk

        gr.Dispose()

    End Sub

    Private Sub MemorySet(ByVal mx As Integer)
        'ﾒﾓﾘｰ設定
        'mx･･･採用ﾊﾞﾝﾄﾞ幅
        Dim aa$
        Dim i, icc, nb As Integer
        Dim b1, freemem, reqmem As Single

        freemem = 1000 * FreeMemoryGet()
        If KindField < 3 Then
            reqmem = 8.0 * Neff * mx * 1.05
        Else
            reqmem = 8.0 * (mx + 10) * (mx + 100)
        End If
        If reqmem > freemem Then
            b1 = reqmem / 100000000.0
            reqmem = (Int(b1) + 1) / 10
            aa$ = "バンド幅が大き過ぎるため、配列変数のメモリーが足りません！"
            aa$ = aa$ + Chr(13) + Chr(10) + "バンドマトリックス法で必要な空きメモリー容量は約"
            aa$ = aa$ + Str(reqmem) + "ＧＢです。"
            MsgBox(aa$, 0, "メモリー不足")
            End
        ElseIf KindField = 3 Then
            b1 = freemem / 8 / (mx + 10) - mx
            NDmatrix = CInt(Neff / b1 + 1)
        End If

        If NDmatrix = 1 Then
            ReDim Tk(Neff, mx)
        Else
            icc = 0
            NxF = Int(Neff / NDmatrix)
            i = Neff Mod NDmatrix
            If i > 0 Then
                NxF = NxF + 1
            End If
            i = Neff - NxF * (NDmatrix - 1)
            If i < mx Then
                icc = 1
            End If
            If icc = 0 Then
                Try
                    ReDim Tk(NxF + mx - 1, mx)
                Catch
                    aa$ = "ＦＥＭ行列の分割メモリーがオーバーしました！"
                    aa$ = aa$ + Chr(13) + Chr(10)
                    aa$ = aa$ + "自動分割の分割数" + LTrim(Str(NDmatrix)) + "では不足です。"
                    MsgBox(aa$, 0, "メモリーエラー")
                    End
                End Try
            Else
                nb = Int(Neff / (mx + 1))
                aa$ = "ＦＥＭ行列分割数が大きすぎます！"
                aa$ = aa$ + Chr(13) + Chr(10)
                aa$ = aa$ + "自動分割の分割数" + LTrim(Str(NDmatrix)) + "を"
                aa$ = aa$ + Str$(nb) + "以下にできません。"
                MsgBox(aa$, 0, "計算条件エラー")
                End
            End If
        End If

    End Sub

    Private Sub OutSurfCheck(ByVal ie As Integer, ByRef mbuf() As Integer)
        '面外部の材料ﾁｪｯｸ
        'ie･･･要素番号
        'mbuf()･･･６面外部の材料番号
        Dim i, ic, icc, ii, imax, j, j2, jj, jmax, jx, k As Integer
        Dim kbuf(8) As Integer

        If KindElem = 0 Then
            imax = 6
            jmax = 8
        End If
        For i = 1 To imax
            mbuf(i) = 0
            If KindElem = 0 Then
                Call SurfaceSet(ie, i, KsurfPoint)  '面の設定
            End If
            k = KsurfPoint(1)
            ic = 0
            For ii = 1 To Nelem
                If ii <> ie And NumMat(ie) <> NumMat(ii) Then
                    For j = 1 To 6
                        Call SurfaceSet(ii, j, kbuf)    '面の設定
                        icc = 0
                        For jj = 1 To jmax
                            If k = kbuf(jj) Then
                                jx = jj
                                For j2 = 2 To jmax
                                    jx = jx - 1
                                    If jx < 1 Then
                                        jx = jmax
                                    End If
                                    If KsurfPoint(j2) <> kbuf(jx) Then
                                        icc = 1
                                        Exit For
                                    End If
                                Next j2
                                If icc = 0 Then
                                    ic = 1
                                End If
                                Exit For
                            End If
                        Next jj
                        If ic > 0 Then
                            mbuf(i) = NumMat(ii)
                            Exit For
                        End If
                    Next j
                End If
                If ic > 0 Then
                    Exit For
                End If
            Next ii
        Next i

    End Sub

    Private Sub QelecSet()
        '節点負荷の計算
        Dim ii, j, jj As Integer
        For ii = 1 To NelecP
            j = KelecP(ii)
            jj = Ndim * (Kcomp(j) - 1) + 1
            Tf(Lcomp(jj)) = Tf(Lcomp(jj)) + QelecP(ii)
        Next ii

    End Sub

    Private Sub QintSet()
        '内部負荷の計算
        Dim i, ib, ie, ig, ii, j, j1, j2, jg, k, kg, kind, nm, nmax, numg As Integer
        Dim dj, dv, qb, s, t, u As Double
        Dim dcos(3) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ie = 1 To Nelem
            nm = NumMat(ie)
            ib = 0
            If KindField = 2 Then
                If KindJdef(nm) > 1 Then
                    ib = 1
                End If
            End If
            If ib = 0 Then
                Select Case KindField
                    Case 0
                        j1 = 2 : j2 = 2
                        kind = 0
                    Case 2
                        If KindJdef(nm) = 0 Then
                            j1 = 1 : j2 = 3
                            kind = 0
                        Else
                            j1 = 2 : j2 = 2
                            kind = 1
                        End If
                    Case 3
                        If KindJdef(nm) = 0 Then
                            j1 = 3 : j2 = 5
                            kind = 0
                        Else
                            j1 = 4 : j2 = 4
                            kind = 1
                        End If
                End Select
                For j = j1 To j2
                    qb = DataMat(nm, j)
                    If qb <> 0 Then
                        For k = 1 To nmax
                            ib = NNelem(ie, k)
                            XE(k) = Xdata(ib)
                            YE(k) = Ydata(ib)
                            ZE(k) = Zdata(ib)
                            Qq(k) = 0
                        Next k

                        If KindElem = 0 Then
                            numg = 0
                            For ig = 1 To Ngaus
                                s = PosGaus(ig)
                                For jg = 1 To Ngaus
                                    t = PosGaus(jg)
                                    For kg = 1 To Ngaus
                                        u = PosGaus(kg)
                                        numg = numg + 1
                                        Call ShapeFunc(1, s, t, u)         '形状関数の計算
                                        Call JacobElem(ie, 0, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                                        dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                                        For i = 1 To 20
                                            Qq(i) = Qq(i) + qb * Shape(i) * dv
                                        Next i
                                    Next kg
                                Next jg
                            Next ig
                        End If
                        If kind = 0 Then
                            For k = 1 To nmax
                                ib = NNelem(ie, k)
                                Select Case KindField
                                    Case 0
                                        ii = ib
                                    Case 2
                                        ii = Ndim * (Kcomp(ib) - 1) + j
                                    Case 3
                                        ii = Ndim * (Kcomp(ib) - 1) + 2 * j - 5
                                End Select
                                Tf(Lcomp(ii)) = Tf(Lcomp(ii)) + Qq(k)
                            Next k
                        Else
                            k = DataMat(nm, j1 - 1)
                            Call Surf2Vector(ie, k, dcos)   '対面方向ﾍﾞｸﾄﾙの計算
                            For k = 1 To nmax
                                ib = NNelem(ie, k)
                                ib = Ndim * (Kcomp(ib) - 1)
                                For i = 1 To 3
                                    Select Case KindField
                                        Case 2
                                            ii = ib + i
                                        Case 3
                                            ii = ib + 2 * i - 1
                                    End Select
                                    Tf(Lcomp(ii)) = Tf(Lcomp(ii)) + Qq(k) * dcos(i)
                                Next i
                            Next k
                        End If
                    End If
                Next j
            End If
        Next ie

        If KindField = 2 Then
            Dim b1 As Double
            Dim buf(3) As Double
            For ie = 1 To Nelem
                nm = NumMat(ie)
                If Kmag(nm) > 0 Then
                    If KindJdef(nm) = 2 Then
                        For j = 1 To 3
                            buf(j) = DataMat(nm, j)
                        Next j
                    Else
                        k = DataMat(nm, 1)
                        b1 = DataMat(nm, 2)
                        Call Surf2Vector(ie, k, dcos)   '対面方向ﾍﾞｸﾄﾙの計算
                        For j = 1 To 3
                            buf(j) = b1 * dcos(j)
                        Next j
                    End If
                    For k = 1 To nmax
                        ib = NNelem(ie, k)
                        XE(k) = Xdata(ib)
                        YE(k) = Ydata(ib)
                        ZE(k) = Zdata(ib)
                    Next k
                    For j = 1 To 3
                        For k = 1 To nmax
                            ib = NNelem(ie, k)
                            XE(k) = Xdata(ib)
                            YE(k) = Ydata(ib)
                            ZE(k) = Zdata(ib)
                            Qq(k) = 0
                        Next k
                        If KindElem = 0 Then
                            numg = 0
                            For ig = 1 To Ngaus
                                s = PosGaus(ig)
                                For jg = 1 To Ngaus
                                    t = PosGaus(jg)
                                    For kg = 1 To Ngaus
                                        u = PosGaus(kg)
                                        numg = numg + 1
                                        Call ShapeFunc(1, s, t, u)         '形状関数の計算
                                        Call JacobElem(ie, 0, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                                        dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                                        For i = 1 To 20
                                            Select Case j
                                                Case 1
                                                    b1 = -Dy(i) * buf(3) + Dz(i) * buf(2)
                                                Case 2
                                                    b1 = -Dz(i) * buf(1) + Dx(i) * buf(3)
                                                Case 3
                                                    b1 = -Dx(i) * buf(2) + Dy(i) * buf(1)
                                            End Select
                                            Qq(i) = Qq(i) + b1 * dv
                                        Next i
                                    Next kg
                                Next jg
                            Next ig
                        End If
                        For k = 1 To nmax
                            ib = NNelem(ie, k)
                            ii = Ndim * (Kcomp(ib) - 1) + j
                            Tf(Lcomp(ii)) = Tf(Lcomp(ii)) + Qq(k)
                        Next k
                    Next j
                End If
            Next ie
        End If

    End Sub

    Private Sub ReqTime(ByVal crate As Single, ByVal rmesh As Single, _
    ByVal b1 As Single)
        '残りの所要時間の計算
        'crate･･･調整係数
        'rmesh･･･残存ﾒｯｼｭ数
        'b1･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b2 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics

        tima$ = ""
        If b1 < 0 Then
            b1 = b1 + 86400
        End If
        b2 = b1 * rmesh / crate
        Call TimConv(tima$, b2)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力1
        'UTF-8･･･BOMなし
        Dim aa$, c1$

        c1$ = ""
        SwK = New IO.StreamWriter(Fy$)  '結果出力用
        SwK.WriteLine("＜＜３次元電磁界解析の計算結果＞＞")
        SwK.WriteLine(Title$)

        aa$ = "［入力データファイル］" + "," + Fm$
        SwK.WriteLine(aa$)

        Select Case KindField
            Case 0
                c1$ = "静電界"
            Case 1
                c1$ = "静磁界（電流なし）"
            Case 2
                c1$ = "静磁界（電流有り）"
            Case 3
                c1$ = "準定常電磁界（渦電流）"
        End Select
        aa$ = "［解析種類］" + c1$
        SwK.WriteLine(aa$)
        If KindField = 1 Or KindField = 2 Then
            If NKmax > 1 Then
                aa$ = "最大繰返し計算回数" + "," + Str(NKmax)
                SwK.WriteLine(aa$)
                aa$ = "収束基準誤差率" + "," + Str(EpsCalc)
                SwK.WriteLine(aa$)
            End If
            If KMenv > 0 Then
                aa$ = "環境材料番号" + "," + Str(KMenv)
                SwK.WriteLine(aa$)
            End If
        End If

    End Sub

    Private Sub ResFile2(ByVal mb As Integer)
        '結果ﾌｧｲﾙへの出力2
        'mb･･･ﾊﾞﾝﾄﾞ幅
        Dim aa$
        Dim n As Integer

        If KindField = 3 And NDmatrix > 1 Then
            aa$ = "ＦＥＭ行列分割数" + "," + Str(NDmatrix)
            SwK.WriteLine(aa$)
        End If
        SwK.WriteLine("-----------------------------------------------")
        SwK.WriteLine("＊＊＊ 計算結果（バンドマトリックス法） ＊＊＊")
        n = Neff * mb
        If KindField < 3 Then
            aa$ = "計算マトリックスの変数個数、ハーフバンド幅、保存インデックス数"
        Else
            aa$ = "計算マトリックスの変数個数、フルバンド幅、保存インデックス数"
        End If
        SwK.WriteLine(aa$)
        aa$ = "   " + Str(Neff) + ",   " + Str(mb) + ",   " + Str(n)
        SwK.WriteLine(aa$)
        SwK.WriteLine("-----------------------------------------------")

    End Sub

    Private Sub ResFile3(ByVal iter As Integer)
        '結果ﾌｧｲﾙへの出力3
        'iter･･･繰返し回数
        Dim aa$
        Dim ib, ip, ii, j, jb As Integer
        Dim b1, b2, b3, b4, z1 As Single
        Dim zbuf(5) As Single

        If iter > 1 Then
            aa$ = "繰返し計算回数" + "," + Str(iter)
            SwK.WriteLine(aa$)
        End If
        SwK.WriteLine("＊＊ 節点の計算出力 ＊＊")
        Select Case KindField
            Case 2
                aa$ = "＜節点番号、Ａx、Ａy、Ａz、全Ａ＞"
                SwK.WriteLine("出力１")
                SwK.WriteLine(aa$)
                For ip = 1 To Npoint
                    aa$ = Str$(ip)
                    ib = 3 * (Kcomp(ip) - 1)
                    b1 = 0
                    For j = 1 To 3
                        z1 = Tf(Lcomp(ib + j))
                        zbuf(j) = z1
                        aa$ = aa$ + ",  " + Str$(z1)
                        b1 = b1 + z1 * z1
                    Next j
                    zbuf(4) = Math.Sqrt(b1)
                    aa$ = aa$ + ",  " + Str$(zbuf(4))
                    SwK.WriteLine(aa$)
                    For ii = 1 To 4
                        If Math.Abs(zbuf(ii)) > Math.Abs(VarMax(ii)) Then
                            VarMax(ii) = zbuf(ii)
                            KVarMax(ii) = ip
                        End If
                    Next ii
                Next ip
                aa$ = "＜節点番号、磁束密度Ｂx、磁束密度Ｂy、"
                aa$ = aa$ + "磁束密度Ｂz、全磁束密度＞"
                SwK.WriteLine("-----------------------------------------------")
                SwK.WriteLine("出力２")
                SwK.WriteLine(aa$)
                For ip = 1 To Npoint
                    aa$ = Str$(ip)
                    ib = 3 * (Kcomp(ip) - 1)
                    b1 = 0
                    For j = 1 To 3
                        z1 = TUvec(ib + j)
                        zbuf(j) = z1
                        aa$ = aa$ + ",  " + Str$(z1)
                        b1 = b1 + z1 * z1
                    Next j
                    zbuf(4) = Math.Sqrt(b1)
                    aa$ = aa$ + ",  " + Str$(zbuf(4))
                    SwK.WriteLine(aa$)
                    For ii = 5 To 8
                        If Math.Abs(zbuf(ii - 4)) > Math.Abs(VarMax(ii)) Then
                            VarMax(ii) = zbuf(ii - 4)
                            KVarMax(ii) = ip
                        End If
                    Next ii
                Next ip
            Case 3
                aa$ = "＜節点番号、Ａx絶対値、Ａy絶対値、Ａz絶対値、全Ａ、"
                aa$ = aa$ + "電位絶対値＞"
                SwK.WriteLine("出力１")
                SwK.WriteLine(aa$)
                For ip = 1 To Npoint
                    aa$ = Str$(ip)
                    ib = 8 * (Kcomp(ip) - 1)
                    b1 = 0
                    For j = 1 To 3
                        jb = 2 * j
                        b2 = Tf(Lcomp(ib + jb - 1))
                        b3 = Tf(Lcomp(ib + jb))
                        b4 = b2 * b2 + b3 * b3
                        z1 = Math.Sqrt(b4)
                        zbuf(j) = z1
                        aa$ = aa$ + ",  " + Str$(z1)
                        b1 = b1 + b4
                    Next j
                    zbuf(4) = Math.Sqrt(b1)
                    aa$ = aa$ + ",  " + Str$(zbuf(4))
                    b2 = Tf(Lcomp(ib + 7))
                    b3 = Tf(Lcomp(ib + 8))
                    b4 = b2 * b2 + b3 * b3
                    zbuf(5) = Math.Sqrt(b4)
                    aa$ = aa$ + ",  " + Str$(zbuf(5))
                    SwK.WriteLine(aa$)
                    For ii = 1 To 5
                        If zbuf(ii) > VarMax(ii) Then
                            VarMax(ii) = zbuf(ii)
                            KVarMax(ii) = ip
                        End If
                    Next ii
                Next ip
                aa$ = "＜節点番号、Ｂx絶対値、Ｂy絶対値、Ｂz絶対値、全磁束密度＞"
                SwK.WriteLine("-----------------------------------------------")
                SwK.WriteLine("出力２")
                SwK.WriteLine(aa$)
                For ip = 1 To Npoint
                    aa$ = Str$(ip)
                    ib = 6 * (Kcomp(ip) - 1)
                    b1 = 0
                    For j = 1 To 3
                        jb = 2 * j
                        b2 = TUvec(ib + jb - 1)
                        b3 = TUvec(ib + jb)
                        b4 = b2 * b2 + b3 * b3
                        z1 = Math.Sqrt(b4)
                        zbuf(j) = z1
                        aa$ = aa$ + ",  " + Str$(z1)
                        b1 = b1 + b4
                    Next j
                    zbuf(4) = Math.Sqrt(b1)
                    aa$ = aa$ + ",  " + Str$(zbuf(4))
                    SwK.WriteLine(aa$)
                    SwK.WriteLine(aa$)
                    For ii = 6 To 9
                        If zbuf(ii - 5) > VarMax(ii) Then
                            VarMax(ii) = zbuf(ii - 5)
                            KVarMax(ii) = ip
                        End If
                    Next ii
                Next ip
                SwK.WriteLine("-----------------------------------------------")
            Case Else
                If KindField = 0 Then
                    aa$ = "＜節点番号、電位、電束密度Ｄx、電束密度Ｄy、"
                    aa$ = aa$ + "電束密度Ｄz、全電束密度＞"
                Else
                    aa$ = "＜節点番号、磁位、磁束密度Ｂx、磁束密度Ｂy、"
                    aa$ = aa$ + "磁束密度Ｂz、全磁束密度＞"
                End If
                SwK.WriteLine(aa$)
                For ip = 1 To Npoint
                    aa$ = Str$(ip)
                    ii = Kcomp(ip)
                    zbuf(1) = Tf(Lcomp(ii))
                    aa$ = aa$ + ",  " + Str$(zbuf(1))
                    ib = 3 * (ii - 1)
                    b1 = 0
                    For j = 1 To 3
                        z1 = TUvec(ib + j)
                        zbuf(j + 1) = z1
                        aa$ = aa$ + ",  " + Str$(z1)
                        b1 = b1 + z1 * z1
                    Next j
                    zbuf(5) = Math.Sqrt(b1)
                    aa$ = aa$ + ",  " + Str$(zbuf(5))
                    SwK.WriteLine(aa$)
                    For ii = 1 To 5
                        If Math.Abs(zbuf(ii)) > Math.Abs(VarMax(ii)) Then
                            VarMax(ii) = zbuf(ii)
                            KVarMax(ii) = ip
                        End If
                    Next ii
                Next ip
        End Select

    End Sub

    Private Sub ResFile4()
        '結果ﾌｧｲﾙへの出力4
        Dim aa$
        Dim ib, ii, ip, j, jb As Integer
        Dim b1, b2, b3, b4, z1 As Single
        Dim zbuf(4) As Single

        aa$ = "＜節点番号、渦Ｊx絶対値、渦Ｊy絶対値、渦Ｊz絶対値、全渦電流密度＞"
        SwK.WriteLine("出力３")
        SwK.WriteLine(aa$)
        For ip = 1 To Npoint
            aa$ = Str$(ip)
            ib = 6 * (Kcomp(ip) - 1)
            b1 = 0
            For j = 1 To 3
                jb = 2 * j
                b2 = TUvec2(ib + jb - 1)
                b3 = TUvec2(ib + jb)
                b4 = b2 * b2 + b3 * b3
                z1 = Math.Sqrt(b4)
                zbuf(j) = z1
                aa$ = aa$ + ",  " + Str$(z1)
                b1 = b1 + b4
            Next j
            b2 = Math.Sqrt(b1)
            TUvec(Kcomp(ip)) = b2
            zbuf(4) = b2
            aa$ = aa$ + ",  " + Str$(zbuf(4))
            SwK.WriteLine(aa$)
            For ii = 10 To 13
                If zbuf(ii - 9) > VarMax(ii) Then
                    VarMax(ii) = zbuf(ii - 9)
                    KVarMax(ii) = ip
                End If
            Next ii
        Next ip
        SwK.WriteLine("-----------------------------------------------")

    End Sub

    Private Sub ResFile5()
        '結果ﾌｧｲﾙへの出力5
        Dim aa$
        Dim i, ic As Integer
        Dim b1, b2, b3, degpai, theta, z1 As Single

        degpai = 180 / Pai
        aa$ = "＜材料番号、 渦電力＞"
        SwK.WriteLine("＊＊ 材料別の渦電力 ＊＊")
        SwK.WriteLine(aa$)
        For i = 1 To Nmat
            If DataMat(i, 2) > 0 Then
                aa$ = Str$(i)
                z1 = WEddy(i)
                aa$ = aa$ + ",  " + Str$(z1)
                SwK.WriteLine(aa$)
            End If
        Next i

        For i = 1 To Nmat
            If DataMat(i, 2) = 0 Then
                ic = 1
                Exit For
            End If
        Next i
        If ic > 0 Then
            aa$ = "＜材料番号、断面積、負荷電流、誘起電圧、"
            aa$ = aa$ + "インピーダンス、複素角＞"
            SwK.WriteLine("＊＊ インピーダンス ＊＊")
            SwK.WriteLine(aa$)
            For i = 1 To Nmat
                If DataMat(i, 2) = 0 Then
                    If KindJdef(i) > 0 And DataMat(i, 4) <> 0 Then
                        aa$ = Str$(i)
                        z1 = Area(i)
                        aa$ = aa$ + ",  " + Str$(z1)
                        z1 = RIe(i)
                        aa$ = aa$ + ",  " + Str$(z1)
                        b1 = RImp(i)
                        b2 = RImpb(i)
                        b3 = b1 * b1 + b2 * b2
                        z1 = Math.Sqrt(b3)
                        aa$ = aa$ + ",  " + Str$(z1)
                        b1 = RImp(i) / RIe(i)
                        b2 = RImpb(i) / RIe(i)
                        b3 = b1 * b1 + b2 * b2
                        z1 = Math.Sqrt(b3)
                        aa$ = aa$ + ",  " + Str$(z1)
                        Call CompAngle(b1, b2, theta)   '複素角の計算
                        z1 = degpai * theta
                        aa$ = aa$ + ",  " + Str$(z1)
                        SwK.WriteLine(aa$)
                    End If
                End If
            Next i
        End If

    End Sub

    Private Sub ResFile6()
        '結果ﾌｧｲﾙへの出力6
        Dim aa$, ad$
        Dim abuf$(13)
        Dim i, imax As Integer
        ad$ = "-------------------------------------------------------"
        aa$ = "注）絶対値の最大。"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜最大値データ＞")
        SwK.WriteLine(aa$)
        CalcRes$ = "＜最大値データ＞" + Cr$ + aa$
        aa$ = "変数項目、      最大値、            節点番号"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        Select Case KindField
            Case 0
                abuf$(1) = "電位"
                abuf$(2) = "電束密度Ｄx"
                abuf$(3) = "電束密度Ｄy"
                abuf$(4) = "電束密度Ｄz"
                abuf$(5) = "全電束密度"
                imax = 5
            Case 1
                abuf$(1) = "磁位"
                abuf$(2) = "磁束密度Ｂx"
                abuf$(3) = "磁束密度Ｂy"
                abuf$(4) = "磁束密度Ｂz"
                abuf$(5) = "全磁束密度"
                imax = 5
            Case 2
                abuf$(1) = "Ａx"
                abuf$(2) = "Ａy"
                abuf$(3) = "Ａz"
                abuf$(4) = "全Ａ"
                abuf$(5) = "磁束密度Ｂx"
                abuf$(6) = "磁束密度Ｂy"
                abuf$(7) = "磁束密度Ｂz"
                abuf$(8) = "全磁束密度"
                imax = 8
            Case 3
                abuf$(1) = "Ａx絶対値"
                abuf$(2) = "Ａy絶対値"
                abuf$(3) = "Ａz絶対値"
                abuf$(4) = "全Ａ"
                abuf$(5) = "電位絶対値"
                abuf$(6) = "磁束密度Ｂx"
                abuf$(7) = "磁束密度Ｂy"
                abuf$(8) = "磁束密度Ｂz"
                abuf$(9) = "全磁束密度"
                abuf$(10) = "Ｊx絶対値"
                abuf$(11) = "Ｊy絶対値"
                abuf$(12) = "Ｊz絶対値"
                abuf$(13) = "全渦電流密度"
                imax = 13
        End Select
        For i = 1 To imax
            aa$ = abuf$(i) + ",  "
            aa$ = aa$ + Space$(14 - Len(aa$)) + Str$(VarMax(i)) + ",  "
            aa$ = aa$ + Space$(34 - Len(aa$)) + Str$(KVarMax(i))
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Cr$ + aa$
        Next i

    End Sub

    Private Sub RestCond(ByVal k As Integer, ByVal mb As Integer, _
        ByVal ub As Double)
        '拘束条件処理
        'k･･･変数番号
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'ub･･･拘束値
        Dim it, j, ka, mx As Integer
        If k > 1 Then
            ka = k - mb + 1
            If ka < 1 Then
                ka = 1
            End If
            For it = ka To k - 1
                j = k - it + 1
                If ub <> 0 Then
                    Tf(it) = Tf(it) - Tk(it, j) * ub
                End If
                Tk(it, j) = 0
            Next it
        End If
        If k < Neff Then
            mx = mb
            If k + mb - 1 > Neff Then
                mx = Neff - k + 1
            End If
            For j = 2 To mx
                If ub <> 0 Then
                    it = k + j - 1
                    Tf(it) = Tf(it) - Tk(k, j) * ub
                End If
                Tk(k, j) = 0
            Next j
        End If
        Tk(k, 1) = 1
        Tf(k) = ub

    End Sub

    Private Sub RestCondA(ByVal k As Integer, ByVal mh As Integer, _
    ByVal ub As Double)
        '拘束条件処理（ﾌﾙﾊﾞﾝﾄﾞ）
        'k･･･変数番号
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'ub･･･拘束値
        Dim it, j, jj, jt, ka, mx As Integer
        If k > 1 Then
            ka = k - mh + 1
            If ka < 1 Then
                ka = 1
            End If
            For it = ka To k - 1
                j = k - it + mh
                jj = mh - k + it
                If ub <> 0 Then
                    Tf(it) = Tf(it) - Tk(it, j) * ub
                End If
                Tk(it, j) = 0
                Tk(k, jj) = 0
            Next it
        End If
        If k < Neff Then
            mx = mh
            If k + mh - 1 > Neff Then
                mx = Neff - k + 1
            End If
            For j = 2 To mx
                it = k + j - 1
                jt = mh + j - 1
                jj = mh - j + 1
                If ub <> 0 Then
                    Tf(it) = Tf(it) - Tk(it, jj) * ub
                End If
                Tk(k, jt) = 0
                Tk(it, jj) = 0
            Next j
        End If
        Tk(k, mh) = 1
        Tf(k) = ub

    End Sub

    Private Sub Solver1(ByVal mb As Integer, ByVal nx As Integer)
        'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, timn$
        Dim i, icount, it, jt, j, k, kdiv, mx As Integer
        Dim crate, dn, fw0, fwx, riter, rmesh, rsec1, rsec2 As Single
        Dim b1 As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        rmesh = 0.8
        dn = nx / 10.0 - 0.001
        riter = dn
        kdiv = 0
        Dim timenew As Date = Now
        rsec1 = TimeLap(Timst, timenew)
        Application.DoEvents()
        icount = 0
        For k = 1 To nx - 1
            mx = mb
            If k + mb - 1 > nx Then
                mx = nx - k + 1
            End If
            b1 = Tk(k, 1)
            For j = 2 To mx
                Ua(j) = Tk(k, j) / b1
            Next j
            Tf(k) = Tf(k) / b1
            For i = 2 To mx
                b1 = Tk(k, i)
                If b1 <> 0 Then
                    it = i + k - 1
                    For j = i To mx
                        If Ua(j) <> 0 Then
                            jt = j - i + 1
                            Tk(it, jt) = Tk(it, jt) - b1 * Ua(j)
                        End If
                    Next j
                    Tf(it) = Tf(it) - b1 * Tf(k)
                End If
            Next i
            riter = riter - 1
            If riter <= 0 Then
                aa$ = "ｿﾙﾊﾞｰ1  k=" + Str$(k) + "  "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)
                If NKmax = 1 Then
                    rmesh = rmesh - 0.06
                    crate = 1 - rmesh
                    fw0 = Fw1
                    fwx = rmesh * Fw1 + crate * Fw2
                    ProgressBar1.Value = 100 * fwx / Fw2
                    If kdiv > 0 And kdiv < 9 Then
                        Dim timenew1 As Date = Now
                        rsec2 = TimeLap(Timst, timenew1)
                        rsec2 = rsec2 - rsec1
                        Call ReqTime(crate - 0.23, rmesh, rsec2)
                        '残りの所要時間の計算
                    End If
                End If
                kdiv = kdiv + 1
                riter = dn
            End If
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next k

        gr.Dispose()

    End Sub

    Sub Solver1A(ByVal mb As Integer, ByVal nx As Integer)
        'ﾌﾙﾊﾞﾝﾄﾞ･ﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ（前進側）
        'mb･･･ﾊ-ﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, timn$
        Dim i, icount, it, j, jk, jt, k, kdiv, mx As Integer
        Dim crate, dn, fw0, fwx, riter, rmesh, rsec1, rsec2 As Single
        Dim pivotvalue, valuex As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        rmesh = 0.8
        dn = nx / 10.0 - 0.001
        riter = dn
        kdiv = 0
        Dim timenew As Date = Now
        rsec1 = TimeLap(Timst, timenew)
        Application.DoEvents()
        icount = 0
        For k = 1 To nx - 1
            mx = mb
            If k + mb - 1 > nx Then   'ﾏﾄﾘｯｸｽの不在列ﾁｪｯｸ
                mx = nx - k + 1
            End If
            pivotvalue = Tk(k, mb)
            If pivotvalue = 0 Then
                'ｴﾗｰ処理
                aa$ = "ソルバーの変数No." + LTrim$(Str$(k)) + "でピボットエラー！"
                aa$ = aa$ + Chr(13) + Chr(10) + "計算を中止します。"
                MsgBox(aa$, 0, "計算エラー")
                End
            Else
                For j = 2 To mx
                    jk = mb + j - 1
                    Tk(k, jk) = Tk(k, jk) / pivotvalue
                Next j
            End If

            Tf(k) = Tf(k) / pivotvalue
            For i = 2 To mx
                it = i + k - 1
                jk = mb - i + 1
                valuex = Tk(it, jk)
                If valuex <> 0 Then
                    For j = 2 To mx
                        jt = j - i + mb
                        jk = mb + j - 1
                        Tk(it, jt) = Tk(it, jt) - valuex * Tk(k, jk)
                    Next j
                    Tf(it) = Tf(it) - valuex * Tf(k)
                End If
            Next i
            riter = riter - 1
            If riter <= 0 Then
                aa$ = "ｿﾙﾊﾞｰ1A  k=" + Str$(k) + "  "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)
                If NKmax = 1 Then
                    rmesh = rmesh - 0.06
                    crate = 1 - rmesh
                    fw0 = Fw1
                    fwx = rmesh * Fw1 + crate * Fw2
                    ProgressBar1.Value = 100 * fwx / Fw2
                    If kdiv > 0 And kdiv < 9 Then
                        Dim timenew1 As Date = Now
                        rsec2 = TimeLap(Timst, timenew1)
                        rsec2 = rsec2 - rsec1
                        Call ReqTime(crate - 0.23, rmesh, rsec2)
                        '残りの所要時間の計算
                    End If
                End If
                kdiv = kdiv + 1
                riter = dn
            End If
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next k

        gr.Dispose()

    End Sub

    Private Sub Solver1AD(ByVal mh As Integer, ByVal k1 As Integer, _
    ByVal k2 As Integer, ByVal nn As Integer)
        'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1AD（前進側）
        'ierror･･･ｴﾗｰ有無（0：なし、-1：有り）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'k1･･･変数の開始番号（第1行）
        'k2･･･変数の終了番号
        'nn･･･行列の行数
        Dim aa$, timn$
        Dim i, icount, j, k, kb, mbf, mx, nxb As Integer
        Dim dn, riter As Single
        Dim b1 As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1AD 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        mbf = 2 * mh - 1
        Dim buf(mbf) As Double

        dn = (k2 - k1 + 1) / 10.0 - 0.001
        riter = dn
        Application.DoEvents()
        icount = 0
        For k = 1 To k2 - k1 + 1
            nxb = k + mh - 1
            If nxb > nn Then
                nxb = nn
            End If
            mx = mbf
            If k + mx - mh > Neff Then
                mx = Neff - k + mh
            End If
            b1 = Tk(k, mh)
            If b1 = 0 Then
                aa$ = "ソルバーの変数No." + LTrim$(Str$(k + k1 - 1))
                aa$ = aa$ + "でピボットエラー！"
                aa$ = aa$ + Chr(13) + Chr(10) + "計算を中止します。"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            For j = mh To mx
                buf(j) = Tk(k, j) / b1
                Tk(k, j) = buf(j)
            Next j
            Tf(k + k1 - 1) = Tf(k + k1 - 1) / b1

            For i = k + 1 To nxb 'ﾋﾟﾎﾞｯﾄ以外の行を掃出し計算
                kb = i - k
                b1 = Tk(i, mh - kb)
                If b1 <> 0 Then
                    For j = mh To mx
                        If buf(j) <> 0 Then
                            Tk(i, j - kb) = Tk(i, j - kb) - b1 * buf(j)
                        End If
                    Next j
                    Tf(i + k1 - 1) = Tf(i + k1 - 1) - b1 * Tf(k + k1 - 1)
                End If
            Next i

            riter = riter - 1
            If riter <= 0 Then
                aa$ = "ｿﾙﾊﾞｰ1AD  k=" + Str$(k) + "  "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)
                riter = dn
            End If
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next k

        gr.Dispose()

    End Sub

    Private Sub Solver2(ByVal mb As Integer, ByVal nx As Integer)
        'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, timn$
        Dim j, jt, k, mx As Integer
        Dim s As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2 計算中" + "   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        For k = nx - 1 To 1 Step -1
            s = 0 : mx = mb
            If k + mb - 1 > nx Then
                mx = nx - k + 1
            End If
            For j = 2 To mx
                jt = j + k - 1
                s = s + Tk(k, j) * Tf(jt)
            Next j
            Tf(k) = Tf(k) - s / Tk(k, 1)
        Next k

        gr.Dispose()

    End Sub

    Private Sub Solver2A(ByVal mb As Integer, ByVal nx As Integer)
        'ﾌﾙﾊﾞﾝﾄﾞ･ﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
        'mb･･･ﾊ-ﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, timn$
        Dim j, jk, jt, k, mx As Integer
        Dim s As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2A 計算中" + "   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        For k = nx - 1 To 1 Step -1
            s = 0
            mx = mb
            If k + mb - 1 > nx Then
                mx = nx - k + 1
            End If
            For j = 2 To mx
                jt = j + k - 1
                jk = mb + j - 1
                s = s + Tk(k, jk) * Tf(jt)
            Next j
            Tf(k) = Tf(k) - s
        Next k

        gr.Dispose()

    End Sub

    Private Sub Solver2AD(ByVal mh As Integer, ByVal k1 As Integer, _
    ByVal k2 As Integer)
        'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2AD（後退側）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'k1･･･変数の開始番号（第1行）
        'k2･･･変数の終了番号
        Dim aa$, timn$
        Dim j, jj, jt, k, mx As Integer
        Dim s As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2AD 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        For k = k2 To k1 Step -1
            s = 0
            mx = mh
            If k + mx - 1 > Neff Then
                mx = Neff - k + 1
            End If
            For j = 2 To mx
                jt = j + k - 1
                jj = mh + j - 1
                s = s + Tk(k - k1 + 1, jj) * Tf(jt)
            Next j
            Tf(k) = Tf(k) - s
        Next k
        gr.Dispose()

    End Sub

    Private Sub Store()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, ib, it, j, jt As Integer
        For i = 1 To Nvar
            If NPrefer(i) > 0 Then
                For j = i To Nvar
                    jt = NPrefer(j)
                    If jt > 0 Then
                        it = NPrefer(i)
                        If it > jt Then
                            ib = it
                            it = jt
                            jt = ib
                        End If
                        Tk(it, jt - it + 1) = Tk(it, jt - it + 1) + Ek(i, j)
                    End If
                Next j
            End If
        Next i

    End Sub

    Private Sub StoreA(ByVal mh As Integer)
        '全体ﾏﾄﾘｯｸｽへの蓄積（ﾌﾙﾊﾞﾝﾄﾞ用）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim i, it, j, jt, km As Integer
        For i = 1 To Nvar
            it = NPrefer(i)
            If it > 0 Then
                For j = 1 To Nvar
                    jt = NPrefer(j)
                    If jt > 0 Then
                        km = jt + mh - it
                        Tk(it, km) = Tk(it, km) + Ek(i, j)
                    End If
                Next j
            End If
        Next i

    End Sub

    Private Sub StoreAD(ByVal mh As Integer, ByVal nbase As Integer, _
    ByVal i1 As Integer, ByVal i2 As Integer)
        '全体ﾏﾄﾘｯｸｽへの蓄積（ﾌﾙﾊﾞﾝﾄﾞ用、分割計算）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nbase･･･分割行列の変数ﾍﾞｰｽ番号
        'i1,i2･･･分割行列におけ変数の開始番号、終了番号
        Dim i, it, itb, j, jt, km, n1, n2 As Integer
        n1 = nbase + i1
        n2 = nbase + i2
        For i = 1 To Nvar
            it = NPrefer(i)
            If n1 <= it And it <= n2 Then
                itb = it - nbase
                For j = 1 To Nvar
                    jt = NPrefer(j)
                    If jt > 0 Then
                        km = jt + mh - it
                        Tk(itb, km) = Tk(itb, km) + Ek(i, j)
                    End If
                Next j
            End If
        Next i

    End Sub

    Private Sub SurfMagForce2(ByVal ie As Integer, ByVal k As Integer, _
    ByVal rmyu0 As Single, ByRef fbuf() As Double)
        '要素辺の磁気力2
        'ie･･･要素番号
        'k･･･面番号
        'rmyu0･･･真空の透磁率
        'fbuf()･･･各座標軸方向の力
        Dim i, ib, j, jj, jmax, k1, k2, kb, kgp1, kgp2, kind, kk, nb, nmax, numg As Integer
        Dim b0, b1, b2, b3, b4, da, dj, xb, yb, zb As Double
        Dim kbuf(8) As Integer
        Dim buf(3), bufx(20), bufy(20), bufz(20), gpos(3) As Double
        Dim rn(3), tensor(3, 3), xbufb(3), ybufb(3), zbuf(3) As Double

        If KindElem = 0 Then
            jmax = 8
            nb = 4
            nmax = 20
            Call SurfaceCond(k, kind, kbuf, gpos)   '境界条件用の面設定
        End If
        For j = 1 To nmax
            ib = NNelem(ie, j)
            XE(j) = Xdata(ib)
            YE(j) = Ydata(ib)
            ZE(j) = Zdata(ib)
            jj = Kcomp(j)
            ib = 3 * (jj - 1)
            bufx(j) = TUvec(ib + 1)
            bufy(j) = TUvec(ib + 2)
            bufz(j) = TUvec(ib + 3)
        Next j

        xb = 0 : yb = 0 : zb = 0
        For j = 2 To jmax Step 2
            kb = kbuf(j)
            xb = xb + Xdata(kb)
            yb = yb + Ydata(kb)
            zb = zb + Zdata(kb)
            Select Case j
                Case 2
                    xbufb(2) = Xdata(kb)
                    ybufb(2) = Ydata(kb)
                    zbuf(2) = Zdata(kb)
                Case 4
                    xbufb(3) = Xdata(kb)
                    ybufb(3) = Ydata(kb)
                    zbuf(3) = Zdata(kb)
            End Select
        Next j
        xbufb(1) = xb / nb
        ybufb(1) = yb / nb
        zbuf(1) = zb / nb

        '面の法線ﾍﾞｸﾄﾙの計算
        b1 = (ybufb(2) - ybufb(1)) * (zbuf(3) - zbuf(1))
        b1 = b1 - (zbuf(2) - zbuf(1)) * (ybufb(3) - ybufb(1))
        b2 = (zbuf(2) - zbuf(1)) * (xbufb(3) - xbufb(1))
        b2 = b2 - (xbufb(2) - xbufb(1)) * (zbuf(3) - zbuf(1))
        b3 = (xbufb(2) - xbufb(1)) * (ybufb(3) - ybufb(1))
        b3 = b3 - (ybufb(2) - ybufb(1)) * (xbufb(3) - xbufb(1))
        b4 = Math.Sqrt(b1 * b1 + b2 * b2 + b3 * b3)
        rn(1) = b1 / b4
        rn(2) = b2 / b4
        rn(3) = b3 / b4

        If KindElem = 0 Then
            Select Case kind
                Case 1
                    kgp1 = 1
                    kgp2 = 2
                    jj = 3
                Case 2
                    kgp1 = 1
                    kgp2 = 3
                    jj = 2
                Case 3
                    kgp1 = 2
                    kgp2 = 3
                    jj = 1
            End Select
            numg = 0
            For k1 = 1 To Ngaus
                gpos(kgp1) = PosGaus(k1)
                For k2 = 1 To Ngaus
                    gpos(kgp2) = PosGaus(k2)
                    numg = numg + 1
                    Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                    '形状関数の計算

                    Call JacobElem2(ie, numg, dj, kbuf)
                    '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                    da = 0
                    For i = 1 To 3
                        b1 = RinvJ(i, jj)
                        da = da + b1 * b1
                    Next i
                    da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)

                    '応力ﾃﾝｿﾙ
                    b1 = 0 : b2 = 0 : b3 = 0
                    For i = 1 To 8
                        kk = kbuf(i)
                        b1 = b1 + Shape(kk) * bufx(kk)
                        b2 = b2 + Shape(kk) * bufy(kk)
                        b3 = b3 + Shape(kk) * bufz(kk)
                    Next i
                    b0 = 0.5 * (b1 * b1 + b2 * b2 + b3 * b3)
                    tensor(1, 1) = (b1 * b1 - b0) / rmyu0
                    tensor(1, 2) = b1 * b2 / rmyu0
                    tensor(1, 3) = b1 * b3 / rmyu0
                    tensor(2, 1) = tensor(1, 2)
                    tensor(2, 2) = (b2 * b2 - b0) / rmyu0
                    tensor(2, 3) = b2 * b3 / rmyu0
                    tensor(3, 1) = tensor(1, 3)
                    tensor(3, 2) = tensor(2, 3)
                    tensor(3, 3) = (b3 * b3 - b0) / rmyu0

                    '面のｶﾞｳｽ点積分
                    For i = 1 To 3
                        buf(i) = 0
                        For j = 1 To 3
                            buf(i) = buf(i) + tensor(i, j) * rn(j)
                        Next j
                        fbuf(i) = fbuf(i) + buf(i) * da
                    Next i
                Next k2
            Next k1
        End If

    End Sub

    Private Sub VectorCalc()
        'ﾍﾞｸﾄﾙ計算
        Dim i, ib, icount, ie, j, nb, nvec As Integer
        Dim b1 As Double
        If KindField < 3 Then
            nvec = 3
        Else
            nvec = 6
        End If
        nb = nvec * Npoint
        If KindField < 3 Then
            For i = 1 To nb
                TUvec(i) = 0
            Next i
        Else
            For i = 1 To nb
                TUvec(i) = 0
                TUvec2(i) = 0
            Next i
        End If
        Tf(0) = 0
        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            Call ElemMatrixV(ie)    '要素ﾏﾄﾘｯｸｽの計算V
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie
        For i = 1 To Npoint
            ib = nvec * (i - 1)
            For j = 1 To nvec
                TUvec(ib + j) = TUvec(ib + j) / Nw(i)
                If KindField = 3 Then
                    If Nw2(i) > 0 Then
                        TUvec2(ib + j) = TUvec2(ib + j) / Nw2(i)
                    Else
                        TUvec2(ib + j) = 0
                    End If
                End If
            Next j
        Next i
        If KindField < 3 Then
            For i = 1 To Npoint
                ib = 3 * (i - 1)
                b1 = 0
                For j = 1 To 3
                    b1 = b1 + TUvec(ib + j) ^ 2
                Next j
                TUA(i) = Math.Sqrt(b1)
            Next i
        End If

    End Sub

    Private Sub ElMa3DCal4_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim a1$, aa$, err$, timn$
        Dim i, icc, iconv, icount, ie, iter, j As Integer
        Dim k, mb, mbx, mx As Integer
        Dim freemem, rmesh, rmeshb, rmeshsum, sec As Single
        Dim bb, bba, bbx, tfb, tfx, tfxx, ub As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        err$ = ""
        timn$ = ""
        Call TimCal(0, timn$)

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""

        Fw1 = 0 : Fw2 = 100

        Call ResFile1U()     '結果ﾌｧｲﾙへの出力1
        rmeshsum = NKmax
        Call GausSet()  'ｶﾞｳｽ点の設定

        Dim xbuf(Npoint), ybuf(Npoint), zbuf(Npoint) As Single
        Call AxisValueTreat(xbuf, ybuf, zbuf)   '座標値の端数処理
        ReDim Kcomp(Npoint)
        For i = 1 To Npoint
            Kcomp(i) = i
        Next i
        Call BandWidth2(mbx, Kcomp)  'ﾊﾞﾝﾄﾞ幅の計算
        Call PnumImproveNew(mb, mbx, xbuf, ybuf, zbuf)  '節点順序の改良
        Erase xbuf, ybuf, zbuf
        Application.DoEvents()

        Call InitialSet1()  '初期設定
        If KindElem = 0 Then
            Call TrSet(Tr)  '節点応力計算のTr行列の設定
        End If

        Call BandWidth(mb)  'ﾊﾞﾝﾄﾞ幅の計算

        If KindField < 3 Then
            NDmatrix = 1
            mx = mb
            ReDim Ua(mx)
        Else
            mx = 2 * mb - 1
        End If

        Call MemorySet(mx)   'ﾒﾓﾘｰ設定

        Call ResFile2(mx)   '結果ﾌｧｲﾙへの出力2

        If NDmatrix > 1 Then
            Label2.Text = "分割計算を実施しています。"
        End If

        icc = 0 : iconv = 0 : iter = 1
        Do
            '進行表示
            If NKmax = 1 Then
                aa$ = "要素計算中"
            Else
                aa$ = "iter=" + Str$(iter) + " 要素計算"
            End If
            Call TimCal(1, timn$)
            aa$ = aa$ + "   " + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)
            If iter > 1 Then
                rmesh = rmesh + 0.2
                ProgressBar1.Value = 100 * rmesh / rmeshsum
                Dim time1 As Date = Now
                sec = TimeLap(Timst, time1)
                rmeshb = rmeshsum - rmesh
                Call ReqTime(rmesh, rmeshb, sec)   '残りの所要時間の計算
            End If

            If Nflux > 0 Then
                Call FluxSet()  '流束の節点への換算
            End If

            If NelecP > 0 Then
                Call QelecSet() '節点負荷の計算
            End If

            If KindField <> 1 Then
                Call QintSet()      '内部負荷の計算
            End If

            If KindField < 3 Or NDmatrix < 2 Then
                Application.DoEvents()
                icount = 0
                For ie = 1 To Nelem
                    aa$ = "要素" + Str$(ie) + "   "
                    Call TimCal(1, timn$)
                    aa$ = aa$ + timn$
                    gr.Clear(Color.White)
                    gr.DrawString(aa$, fnt, myBrush, 1, 1)
                    If KindField < 3 Then
                        Call ElemMatrix(ie, iter)   '要素ﾏﾄﾘｯｸｽの計算
                        Call Store()       '全体ﾏﾄﾘｯｸｽへの蓄積
                    Else
                        j = 0
                        Call ElemMatrixC(ie, mb, 0, 0, 0, j)  '要素ﾏﾄﾘｯｸｽの計算C
                        Call StoreA(mb)                 '全体ﾏﾄﾘｯｸｽへの蓄積A
                    End If
                    If icount < 99 Then
                        icount = icount + 1
                    Else
                        Application.DoEvents()
                        icount = 0
                    End If
                Next ie

                '進行表示
                If NKmax = 1 Then
                    aa$ = "ｿﾙﾊﾞｰ計算中"
                Else
                    aa$ = "iter=" + Str$(iter) + " ｿﾙﾊﾞｰ計算"
                End If
                Call TimCal(1, timn$)
                aa$ = aa$ + "   " + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)
                rmesh = rmesh + 0.2
                ProgressBar1.Value = 100 * rmesh / rmeshsum
                If NKmax > 1 Then
                    Dim timenew1 As Date = Now
                    sec = TimeLap(Timst, timenew1)
                    rmeshb = rmeshsum - rmesh
                    Call ReqTime(rmesh, rmeshb, sec)   '残りの所要時間の計算
                End If

                For i = 1 To NBvar
                    k = KBfix(i)
                    ub = VBfix(i)
                    If KindField < 3 Then
                        Call RestCond(k, mb, ub)    '拘束条件処理
                    Else
                        Call RestCondA(k, mb, ub)   '拘束条件処理（ﾌﾙﾊﾞﾝﾄﾞ）
                    End If
                Next i

                If KindField < 3 Then
                    Call Solver1(mb, Neff)   'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）
                    Tf(Neff) = Tf(Neff) / Tk(Neff, 1)
                    Application.DoEvents()
                    Call Solver2(mb, Neff)   'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
                Else
                    Call Solver1A(mb, Neff)  'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1A（前進側）
                    Tf(Neff) = Tf(Neff) / Tk(Neff, mb)
                    Application.DoEvents()
                    Call Solver2A(mb, Neff)  'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
                End If
            Else
                For i = 1 To Neff
                    Tfbuf(i) = Tf(i)
                Next i
                Call MatrixCalcD(mb)  'ﾏﾄﾘｯｸｽ計算（分割計算）
            End If

            '進行表示
            If NKmax = 1 Then
                aa$ = "後計算中"
            Else
                aa$ = "iter=" + Str$(iter) + " 後計算"
            End If
            Call TimCal(1, timn$)
            aa$ = aa$ + "   " + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)
            If KindField < 3 Or NDmatrix < 2 Then
                rmesh = rmesh + 0.6
            Else
                rmesh = rmesh + 0.8
            End If
            ProgressBar1.Value = 100 * rmesh / rmeshsum
            Dim timenew As Date = Now
            sec = TimeLap(Timst, timenew)
            rmeshb = rmeshsum - rmesh
            Call ReqTime(rmesh, rmeshb, sec)   '残りの所要時間の計算

            Application.DoEvents()
            Call VectorCalc()   'ﾍﾞｸﾄﾙ計算

            If iter = NKmax Then
                icc = 1
                If NKmax = 1 Then
                    iconv = 1
                End If
            Else
                Call FluctCheck(bb, bba)   '解の発散ﾁｪｯｸ
                If iter > 1 Then
                    If bba >= bb Then
                        iconv = 1
                        icc = 1
                    ElseIf iter > 2 Then
                        If bbx > bb * 0.1 And bb > 5 * bbx Then '解の発散により計算中止
                            icc = 1
                        End If
                    End If
                    If bb > bbx Then
                        For i = 1 To Neff
                            tfb = Tf(i)
                            tfx = TfOld(i)
                            tfxx = TfOldx(i)
                            Call RelaxCalc(tfb, tfx, tfxx) '緩和計算
                            Tf(i) = tfb
                        Next i
                        Call FluctCheck(bb, bba)   '速度の発散ﾁｪｯｸ
                        Call VectorCalc()   'ﾍﾞｸﾄﾙ計算
                    End If
                End If
                If icc = 0 Then
                    bbx = bb
                    For i = 1 To Neff
                        TfOldx(i) = TfOld(i)
                        TfOld(i) = Tf(i)
                    Next i
                    If KindField < 3 Or NDmatrix < 2 Then
                        For i = 1 To Neff
                            For j = 1 To mx
                                Tk(i, j) = 0
                            Next j
                        Next i
                    End If
                    For i = 1 To Neff
                        Tf(i) = 0
                    Next i
                    iter = iter + 1
                End If
            End If
        Loop Until icc > 0

        If iconv > 0 Then
            Call ResFile3(iter)     '結果ﾌｧｲﾙへの出力3
            Application.DoEvents()
            Select Case KindField
                Case 0
                    If NelecP > 0 Then
                        Call ElecForce()    'ｸ-ﾛﾝ力の計算
                    End If
                    Call ElecForce2()    '電荷部のｸ-ﾛﾝ力の計算
                Case 1
                    If KMenv > 0 And NMdivMax > 0 Then
                        Call MagForce2()    '磁気力の計算2
                    End If
                Case 2
                    Call ForceCalc()    '力の計算
                    If KMenv > 0 And NMdivMax > 0 Then
                        Call MagForce2()    '磁気力の計算2
                    End If
                Case 3
                    Call ResFile4()     '結果ﾌｧｲﾙへの出力4
                    Call EddyPower()    '渦電力の計算
                    If KindElem = 0 Then
                        Call Impedance()    'ｲﾝﾋﾟｰﾀﾞﾝｽの計算
                        Call ResFile5()     '結果ﾌｧｲﾙへの出力5
                    End If
            End Select
            Call ResFile6()         '結果ﾌｧｲﾙへの出力6
        Else
            err$ = "解が収束しませんでした！"
            SwK.WriteLine(err$)
        End If

        '進行表示
        ProgressBar1.Value = 100

        Call TimCal(1, timn$)
        freemem = Int(FreeMemoryGet() / 1000.0)
        aa$ = "END   " + timn$ + "   " + Str(freemem) + "MB free"
        SwK.WriteLine(aa$)
        SwK.Close()

        Label1.Text = "計算終了！"
        Label2.Text = "計算結果をファイルへ出力しました。"
        Label3.Text = aa$
        If iconv > 0 Then
            aa$ = "計算が終了しました。"
            aa$ = aa$ + Cr$ + CalcRes$
        Else
            aa$ = err$
        End If
        a1$ = "計算確認"
        Me.BringToFront()
        If KindBatch = 0 Then
            MsgBox(aa$, 0, a1$)
        Else
            Kfinish = 1
        End If
        gr.Dispose()

        Me.Close()

    End Sub
End Class
